//
//  DaiKeXiaDanGouWuCell.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/27.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
protocol DaiKeXiaDanGouWuCellDelegate {
    func DaiKeXiaDanGouWuCellDelAction(cell:DaiKeXiaDanGouWuCell)
    func DaiKeXiaDanGouWuCellRemarkChange(cell:DaiKeXiaDanGouWuCell)
    func DaiKeXiaDanGouWuCell_check(cell:DaiKeXiaDanGouWuCell)
    func DaiKeXiaDanGouWuCell_select_pi_ci(cell:DaiKeXiaDanGouWuCell)
}
class DaiKeXiaDanGouWuCell: UITableViewCell,UITextViewDelegate {
    @IBOutlet weak var bottom_margin: NSLayoutConstraint!
    @IBOutlet weak var dj_wk_view: UIView!
    @IBOutlet weak var dj_wk_top: NSLayoutConstraint!
    @IBOutlet weak var btm_line: UIView!
    @IBOutlet weak var arrow_img: UIImageView!
    @IBOutlet weak var check_button: UIButton!
    var isFx = false
    
    @IBOutlet weak var botton_height: NSLayoutConstraint!
    var delegate:DaiKeXiaDanGouWuCellDelegate?
    @IBOutlet weak var bz_lbl: UILabel!
    @IBOutlet weak var changeBtn: UIButton!
    @IBOutlet weak var count_lbl: UILabel!
    @IBOutlet weak var btmLIneWidth: NSLayoutConstraint!
    
    @IBOutlet weak var delBtn: UIButton!
    @IBOutlet weak var delImg: UIImageView!
    
    @IBOutlet weak var yong_jin_lbl: UILabel!
    @IBOutlet weak var xiao_ji_lbl: UILabel!
    @IBOutlet weak var detailLbl: UILabel!
    @IBOutlet weak var titleLbl: UILabel!
    @IBOutlet weak var dan_jia_lbl: UILabel!
    
    @IBOutlet weak var dj_wk_height: NSLayoutConstraint!
    @IBOutlet weak var ding_jin_lbl: UILabel!
    @IBOutlet weak var wei_kuan_lbl: UILabel!
    
    @IBOutlet weak var non_add_icon: UIImageView!
    
    @IBOutlet weak var right_margin: NSLayoutConstraint!
    @IBOutlet weak var status_text_lbl: UILabel!
    @IBOutlet weak var already_add_icon: UIImageView!
    @IBOutlet weak var text_line: UIView!
    @IBAction func select_pi_ci_action(_ sender: UIButton) {
        delegate?.DaiKeXiaDanGouWuCell_select_pi_ci(cell: self)
    }
    override func layoutSubviews() {
        super.layoutSubviews()
        if isFx{
            bottom_margin.constant = 36
            bz_lbl.isHidden = true
            holder_lbl.isHidden = true
            content_tv.isHidden = true
            edit_img.isHidden = true
            delImg.isHidden = true
            delBtn.isHidden = true
            dan_jia_lbl.isHidden = false
            xiao_ji_lbl.isHidden = false
            dj_wk_top.constant = 0
            dj_wk_height.constant = 0
            dj_wk_view.isHidden = true
        }
    }
    @IBOutlet weak var yu_shou_img: UIImageView!
    var isDetail = false{
        didSet{
            if isDetail {
                bz_lbl.isHidden = false
                content_tv.isUserInteractionEnabled = false
                edit_img.isHidden = true
                delImg.isHidden = true
                delBtn.isHidden = true
                holder_lbl.isHidden = true
                
            }
        }
    }
    @IBAction func delAction(_ sender: Any) {
        delegate?.DaiKeXiaDanGouWuCellDelAction(cell: self)
    }
    @IBOutlet weak var content_tv: UITextView!
    @IBOutlet weak var edit_img: UIImageView!
    @IBOutlet weak var holder_lbl: UILabel!
    @IBOutlet weak var imgView: UIImageView!
    override func awakeFromNib() {
        super.awakeFromNib()
        self.selectionStyle = .none
        content_tv.delegate = self
        // Initialization code
    }
    @IBAction func check_action(_ sender: UIButton) {
        delegate?.DaiKeXiaDanGouWuCell_check(cell: self)
    }
    
    
    func textViewDidChange(_ textView: UITextView) {
        if textView.text.count > 0 {
            holder_lbl.isHidden = true
        }else{
            holder_lbl.isHidden = false
        }
        delegate?.DaiKeXiaDanGouWuCellRemarkChange(cell: self)
    }
    override func setSelected(_ selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)
        
        // Configure the view for the selected state
    }
    
}
