//
//  FX_Product_GuanLiVC.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/11/3.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit


class FX_Product_GuanLiVC: BaseViewController,UITableViewDelegate,UITableViewDataSource, UISearchBarDelegate, SearchBarViewDelegate,GYS_FX_ProductCellDelegate ,SelectContentViewDelegate,HeaderSelectViewDelegate,DistributorSettingAlertViewDelegate{
    
    @IBOutlet weak var all_select_btn: UIButton!
    @IBAction func select_mode_Action(_ sender: UIButton) {
        if selectItem.count == 0 {
            return
        }
        let vc = DistributorSettingAlertView(frame: self.view.bounds)
        vc.delegate = self
      
        if selectItem.count > 1 {
            vc.is_all_select_mode = is_Edit
        }
        self.view.addSubview(vc)
    }
    
    func DistributorSettingAlertViewSubmitAction(tag: Int, operation_type: Int, dbt_price: String, commission_type: Int, commission_per: String, commission_val: String,view:DistributorSettingAlertView) {
        HUD.flash(.progress, delay: 1.2)
        if is_Edit {
            
            
            
            var sku_id = ""
            for i in 0 ..< selectItem.count {
                let model = selectItem[i]
                if i < selectItem.count-1{
                    sku_id += StringByInt(number: model) + ","
                }else{
                    sku_id += StringByInt(number: model)
                }
            }
            
            let dic = ["user_token":UserToken as Any,
                       "operation_type":operation_type as Any,
                       "sku_id":sku_id as Any,
                       "dbt_price":dbt_price as Any,
                       "commission_type":1 as Any,
                       "commission_per":commission_per as Any,
                       "commission_val":commission_val as Any]
            supSetCommodity(dic) { (data) in
                HUD.flash(.label("设置成功~"), delay: 1.2)
                view.removeFromSuperview()
                self.navbar.rightTitle = "编辑商品"
                self.is_Edit = false
                self.edit_bottom_view_H.constant = 0
                self.selectItem.removeAll()
                self.home_list_tbv.mj_header?.beginRefreshing()
                HUD.hide()
            } failture: { (err) in}
            return
        }
        
        let model = datas[tag]
        let dic = ["user_token":UserToken as Any,
                   "operation_type":operation_type as Any,
                   "sku_id":model.sku_id as Any,
                   "dbt_price":dbt_price as Any,
                   "commission_type":commission_type as Any,
                   "commission_per":commission_per as Any,
                   "commission_val":commission_val as Any]
        supSetCommodity(dic) { (data) in
            HUD.flash(.label("设置成功~"), delay: 1.2)
            view.removeFromSuperview()
            self.home_list_tbv.mj_header?.beginRefreshing()
            HUD.hide()
        } failture: { (err) in}
    }
    
    func GYS_FX_ProductCellTableViewCellBtnAction(idx: Int) {
        let vc = DistributorSettingAlertView(frame: self.view.bounds)
        vc.tag = idx
        vc.data = datas[idx]
        vc.delegate = self
        self.view.addSubview(vc)
    }
    
    var datas:Array<supGoodsListResDataModel> = []
    var selectIndexArr = [0,0]
    var showSelectvIndex = 0
    
    var page : Int = 0
    var isUpData = false
    let UserToken = UserDefaults.standard.value(forKey: "user_token")
    
    weak var showSelectV: SelectContentView! = nil
    func didselectCell(sender: Int, SelectContentView: SelectContentView) {
        selectIndexArr[showSelectvIndex] = sender
        var arr:[String] = []
        if showSelectvIndex == 0 {
            let arr1 = ["全部商品", "不参与分销商品", "参与分销商品", "提成比例商品", "绝对额比例商品"]
            arr.append(arr1[sender])
        }else if showSelectvIndex == 1{
            let arr2 = ["上架", "下架"]
            arr.append(arr2[sender])
        }
        selectV.colseBytitleArr(arr: arr, index:showSelectvIndex)
        home_list_tbv.mj_header?.beginRefreshing()
    }
    
    func selectContentvRemoveForSup() {
        selectV.colseBytitleArr(arr: [], index:showSelectvIndex)
    }
    
    func showAction(sender: Int) {
        showSelectvIndex = sender
        switch sender {
        case 0:
            do {
                let showSelectView = SelectContentView()
                showSelectView.delegate = self
                self.view.addSubview(showSelectView)
                showSelectView.snp.makeConstraints { (make) in
                    make.left.right.bottom.equalToSuperview()
                    make.top.equalTo(top_btn_bg_view.snp_bottom)
                }
                showSelectV = showSelectView
                showSelectView.dataArr = ["全部商品", "不参与分销商品", "参与分销商品", "提成比例商品", "绝对额比例商品"]
                showSelectView.selectIndx = selectIndexArr[0]
            }
            break
        case 1:
            do {
                let showSelectView = SelectContentView()
                showSelectView.delegate = self
                self.view.addSubview(showSelectView)
                showSelectView.snp.makeConstraints { (make) in
                    make.left.right.bottom.equalToSuperview()
                    make.top.equalTo(top_btn_bg_view.snp_bottom)
                }
                showSelectV = showSelectView
                showSelectView.dataArr = ["上架", "下架"]
                showSelectView.selectIndx = selectIndexArr[1]
            }
            break
        default: break
            
        }
    }
    
    func colseAction(sender: Int) {
        if showSelectV != nil {
            showSelectV.removeFromSuperview()
        }
    }
    
    var keyword = ""
    func searchBarSearchButtonClicked(_ searchBar: UISearchBar) {
        print("点击搜索进行--")
        searchBar.resignFirstResponder()
        keyword = searchBar.text!
        removeBlackBtnView()
        home_list_tbv.mj_header?.beginRefreshing()
    }
    
    @objc func removeBlackBtnView(){
        if blackBtnView != nil {
            blackBtnView.removeFromSuperview()
            searchV!.resignFirstResponder()
        }
    }
    
    var blackBtnView:UIButton! = nil
    
    //MARK:--取消搜索代理
    func clearSearchAction() {
        print("取消搜索代理了--")
    }
    
    func searchBarTextDidEndEditing(_ searchBar: UISearchBar) {
        print("编辑即将结束了--")
        removeBlackBtnView()
        if keyword.count > 0 {
            keyword = searchBar.text!
            if keyword.count == 0 {
                loadData()
            }
        }
    }
    
    func searchBarShouldBeginEditing(_ searchBar: UISearchBar) -> Bool {
        print("调起搜索后添加个蒙版本")
        if showSelectV != nil {
            showSelectV.removeFromSuperview()
            selectV.colseBytitleArr(arr: [], index: showSelectvIndex)
        }
        blackBtnView = UIButton ()
        blackBtnView.backgroundColor = UIColor.init(named: "提示视图背景色")
        self.view.addSubview(blackBtnView)
        blackBtnView.snp.makeConstraints { (make) in
            make.top.equalTo(search_view!.snp_bottom)
            make.left.right.bottom.equalToSuperview()
        }
        blackBtnView.addTarget(self, action: #selector(removeBlackBtnView), for: .touchUpInside)
        return true
    }
    
    @IBAction func allSelect(_ sender: UIButton) {
        sender.isSelected = !sender.isSelected
        selectItem.removeAll()
        if sender.isSelected {
            datas.forEach { (model) in
                selectItem.append(model.sku_id!)
            }
        }
        all_select_btn.setTitle("  全选(已选 " + StringByInt(number: selectItem.count) + " 件商品)", for: .normal)
        all_select_btn.setTitle("  全选(已选 " + StringByInt(number: selectItem.count) + " 件商品)", for: .selected)
        home_list_tbv.reloadData()
    }
    
    var is_Edit = false
    func rightBtnClick() {
        if showSelectV != nil {
            showSelectV.removeFromSuperview()
            selectV.colseBytitleArr(arr: [], index: showSelectvIndex)
        }
        removeBlackBtnView()
        is_Edit = !is_Edit
        navbar.rightTitle = "编辑商品"
        all_select_btn.isSelected = false
        
        edit_bottom_view_H.constant = 0
        if is_Edit{
            navbar.rightTitle = "取消"
            if IS_IPHONE_X {
                edit_bottom_view_H.constant = 83
            }else{
                edit_bottom_view_H.constant = 49
            }
        }else{
            selectItem.removeAll()
            self.all_select_btn.setTitle("  全选(已选 " + StringByInt(number: self.selectItem.count) + " 件商品)", for: .normal)
        }
        home_list_tbv.reloadData()
    }
    
    @IBOutlet weak var home_list_tbv: UITableView!
    @IBOutlet weak var right_title: UILabel!
    @IBOutlet weak var left_title: UILabel!
    @IBOutlet weak var right_arrow_img: UIButton!
    @IBOutlet weak var left_arrow_img: UIImageView!
    @IBOutlet weak var count_lbl: UILabel!//数量
    @IBOutlet weak var search_view: UIView!
    weak var searchV: SearchBarView? = nil
    weak var selectV: HeaderSelectView! = nil
    
    @IBOutlet weak var top_btn_bg_view: UIView!
    @IBOutlet weak var edit_bottom_view_H: NSLayoutConstraint!
    
    func initHeaderSelectView() {
        let selectView = HeaderSelectView()
        selectView.firstBtn.setTitle("全部商品", for: .normal)
        selectView.secBtn.setTitle("上架", for: .normal)
        selectView.thereBtn.removeFromSuperview()
        selectView.firstBtn.snp_makeConstraints { (make) in
            make.left.top.bottom.equalTo(0)
            make.width.equalTo(fullScreenWidth*0.5)
        }
        selectView.secBtn.snp_makeConstraints { (make) in
            make.right.top.bottom.equalTo(0)
            make.width.equalTo(fullScreenWidth*0.5)
        }
        top_btn_bg_view.addSubview(selectView)
        selectView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalTo(0);
        }
        selectView.delegate = self
        selectV = selectView
    }
    
    override func viewDidLoad() {
        super.viewDidLoad()
        SetTopFrame(view: search_view, height: 44)
        navbar.title = "分销商品管理"
        self.view.addSubview(navbar)
        navbar.rightTitle = "编辑商品"
        
        let searchBr = SearchBarView.init()
        searchV = searchBr
        searchBr.placeholderStr = "请输入分销商品名称"
        self.search_view.addSubview(searchBr)
        searchV?.changecornerRadius(cornerRadius: 35*0.5)
        searchBr.delegate = self
        searchBr.delegateL = self
        searchBr.snp.makeConstraints { (make) in
            make.left.equalTo(0)
            make.right.equalTo(0)
            make.centerY.equalToSuperview()
            make.height.equalTo(35)
        }
        
        initHeaderSelectView()
        
        home_list_tbv.register(UINib(nibName: "GYS_FX_ProductCellTableViewCell", bundle: nil), forCellReuseIdentifier: "GYS_FX_ProductCellTableViewCell")
        home_list_tbv.separatorStyle = .none
        // Do any additional setup after loading the view.
        //下拉刷新相关设置
        self.headerMJ.setRefreshingTarget(self, refreshingAction: #selector(self.loadData))
        self.home_list_tbv.mj_header = self.headerMJ
        self.home_list_tbv.mj_header?.beginRefreshing()
        //上拉加载相关设置
        self.footerMJ.setRefreshingTarget(self, refreshingAction: #selector(self.loadMoreData))
        self.home_list_tbv.mj_footer = self.footerMJ
    }
    
    //MARK: - tableview_delegate
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return datas.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let model = datas[indexPath.row]
        let cell = tableView.dequeueReusableCell(withIdentifier: "GYS_FX_ProductCellTableViewCell") as! GYS_FX_ProductCellTableViewCell
        cell.submitBtn.setTitle("设置", for: .normal)
        cell.submitBtn.setTitleColor(UIColor(named: "按钮背景颜色"), for: .normal)
        cell.tag = indexPath.row
        cell.delegate = self
        if is_Edit{
            cell.leftValue.constant = 45
            cell.submit_Btn_W.constant = 10
            cell.submitBtn.isHidden = true
            cell.left_btn.isUserInteractionEnabled = true
            cell.select_Img.isHidden = false
            cell.select_Img.image = UIImage(named: "daixuan")
            
            selectItem.forEach { (idx) in
                if idx == model.sku_id{
                    cell.select_Img.image = UIImage(named: "yuxuan")
                }
            }
        }else{
            cell.leftValue.constant = 0
            cell.submit_Btn_W.constant = 50
            cell.submitBtn.isHidden = false
            cell.left_btn.isUserInteractionEnabled = false
            cell.select_Img.isHidden = true
        }
        
        
        cell.old_price_line.isHidden = false
        cell.new_price_Lbl.isHidden = false
        if model.dbt_price == nil {
            cell.old_price_line.isHidden = true
            cell.new_price_Lbl.text = ""
        }else{
            cell.new_price_Lbl.text = "¥" + model.dbt_price!
        }
        
        cell.old_price_Lbl.text = "¥" + model.price!
        if model.commission_type == 1{
            cell.FX_Percent_Lbl.isHidden = false
            
            cell.FX_Percent_Lbl.text = "分销(" + StringByInt(number: model.commission_per!) + "%)"
        }else if model.commission_type == 2{
            cell.FX_Percent_Lbl.isHidden = false
            cell.FX_Percent_Lbl.text = "分销(" + model.commission_val! + "元)"
        }else{
            cell.FX_Percent_Lbl.isHidden = true
        }
        cell.title_Lbl.text = model.goods_name
        cell.sell_total_Lbl.text = "销量:-"
        if model.dbt_sale != nil {
            cell.sell_total_Lbl.text = "销量:" + StringByInt(number: model.dbt_sale!)
        }
        cell.store_lbl.text = "库存:-"
        if model.inventory != nil {
            cell.store_lbl.text = "库存:" + StringByInt(number: model.inventory!)
        }
        if model.goods_thumb != nil {
            cell.item_Icon_Img.sd_setImage(with:URL(string:SERVERCE_ImageHost +  model.goods_thumb!), placeholderImage: nil,options:.allowInvalidSSLCertificates)
            
        }
        cell.color_lbl.isHidden = cell.FX_Percent_Lbl.isHidden
        cell.color_lbl.text = cell.FX_Percent_Lbl.text
        return cell
    }
    var selectItem:Array<Int> = []
    func GYS_FX_ProductCellTableViewCellSelect(idx: Int) {
        
        let model = datas[idx]
        if selectItem.contains(model.sku_id!){
            let index = selectItem.firstIndex(of: model.sku_id!)
            selectItem.remove(at: index!)
            
        }else{
            selectItem.append(model.sku_id!)
        }
        all_select_btn.isSelected = false
        all_select_btn.setTitle("  全选(已选 " + StringByInt(number: selectItem.count) + " 件商品)", for: .normal)
        home_list_tbv.reloadData()
    }
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 125
    }
    
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        
    }
    
    var is_show = 1
    var goods_type = 1
    
    
    //MARK:--加载数据
    @objc func loadData(){
        print("加载数据")
        
        page = 1
        isUpData = true
        goods_type = selectIndexArr.first! + 1
        if selectIndexArr.last == 1 {
            is_show = 0
        }else{
            is_show = 1
        }
        
        let dic = ["user_token":UserToken as Any,"keyword":keyword as Any,"page":page as Any,"goods_type":goods_type as Any,"is_show":is_show as Any]
        
        supGoodsList(dic) { (data) in
          
            let model = data  as! supGoodsListModel
            self.datas.removeAll()
            self.count_lbl.text = "-"
            if model.data!.count! > 0 || model.data?.count != nil{
                self.count_lbl.text = StringByInt(number: model.data!.count!)
            }
            model.data?.res?.forEach({ (item) in
                self.datas.append(item)
            })
            self.home_list_tbv.reloadData()
            self.home_list_tbv?.mj_header?.endRefreshing()
            self.page = 2
            
            if self.selectItem.count > 0 {
                self.selectItem.removeAll()
                self.all_select_btn.isSelected = false  
                self.all_select_btn.setTitle("  全选(已选 " + StringByInt(number: self.selectItem.count) + " 件商品)", for: .normal)
            }
            if model.data?.res?.count == 0  {
                self.home_list_tbv?.mj_footer?.endRefreshingWithNoMoreData()
                self.all_select_btn.isUserInteractionEnabled = false
            }else{
                self.home_list_tbv?.mj_footer?.endRefreshing()
                self.all_select_btn.isUserInteractionEnabled = true
            }
        } failture: { (err) in
            self.home_list_tbv?.mj_header?.endRefreshing()
        }
    }
    //MARK:--加载更多数据
    @objc func loadMoreData(){
        print("加载更多数据")
        let dic = ["user_token":UserToken as Any,"keyword":keyword as Any,"page":page as Any,"goods_type":goods_type as Any,"is_show":is_show as Any]
        
        supGoodsList(dic, success: { (data) in
            let model = data  as! supGoodsListModel
            if model.data?.res?.count == 0  {
                self.home_list_tbv?.mj_footer?.endRefreshingWithNoMoreData()
            }else{
                self.page += 1
                model.data?.res?.forEach({ (item) in
                    self.datas.append(item)
                })
                	
                if self.all_select_btn.isSelected {
                    self.selectItem.removeAll()
                    self.datas.forEach { (model) in
                        self.selectItem.append(model.sku_id!)
                    }
                    self.all_select_btn.setTitle("  全选(已选 " + StringByInt(number: self.selectItem.count) + " 件商品)", for: .selected)
                }
                
                self.home_list_tbv.reloadData()
                self.home_list_tbv?.mj_footer?.endRefreshing()
            }
        }) { (error) in
            self.home_list_tbv?.mj_footer?.endRefreshing()
        }
    }
    
}
