//
//  RetailManageFooterView.swift
//  GeliBusinessPlatform
//
//  Created by 刘俊宏 on 2020/11/11.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
protocol RetailManageFooterViewDelagte {
    func tapRetailManageFooterBtnAction(sender:Int)
}
class RetailManageFooterView: UIView {
    var delgate : RetailManageFooterViewDelagte?
    var contentView:UIView!

    @IBAction func ActionByBtn(_ sender: UIButton) {
        delgate?.tapRetailManageFooterBtnAction(sender: sender.tag)
    }
    @IBOutlet weak var priceLbl: UILabel!
    @IBOutlet weak var actionBtn: UIButton!
    @IBOutlet weak var moneyLbl: UILabel!
    @IBOutlet weak var contentBgView: UIView!
    //初始化时将xib中的view添加进来
    override init(frame: CGRect) {
        super.init(frame: frame)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
        contentBgView.layer.cornerRadius = 10;
        contentBgView.layer.maskedCorners = [CACornerMask.layerMinXMaxYCorner,CACornerMask.layerMaxXMaxYCorner]

     }
    //    /初始化时将xib中的view添加进来
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
        contentBgView.layer.cornerRadius = 10;
        contentBgView.layer.maskedCorners = [CACornerMask.layerMinXMaxYCorner,CACornerMask.layerMaxXMaxYCorner]
     }
    //加载xib
    func loadViewFromNib() -> UIView {
        let className = type(of: self)
        let bundle = Bundle(for: className)
        let name = NSStringFromClass(className).components(separatedBy: ".").last
        let nib = UINib(nibName: name!, bundle: bundle)
        let view = nib.instantiate(withOwner: self, options: nil).first as! UIView
        return view
    }

}
