//
//  RetailManageHeaderView.swift
//  GeliBusinessPlatform
//
//  Created by 刘俊宏 on 2020/11/11.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit

class RetailManageHeaderView: UIView {
    var contentView:UIView!


    @IBOutlet weak var contentBgView: UIView!
    
    @IBOutlet weak var stateLbl: UILabel!
    @IBOutlet weak var snNumLbl: UILabel!

    //初始化时将xib中的view添加进来
    override init(frame: CGRect) {
        super.init(frame: frame)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
       contentBgView.layer.cornerRadius = 10;
        contentBgView.layer.maskedCorners = [CACornerMask.layerMinXMinYCorner,CACornerMask.layerMaxXMinYCorner]

     }
    //    /初始化时将xib中的view添加进来
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
        contentBgView.layer.cornerRadius = 10;
        contentBgView.layer.maskedCorners = [CACornerMask.layerMinXMinYCorner,CACornerMask.layerMaxXMinYCorner]
     }
    //加载xib
    func loadViewFromNib() -> UIView {
        let className = type(of: self)
        let bundle = Bundle(for: className)
        let name = NSStringFromClass(className).components(separatedBy: ".").last
        let nib = UINib(nibName: name!, bundle: bundle)
        let view = nib.instantiate(withOwner: self, options: nil).first as! UIView
        return view
    }
}
