//
//  DZSH_Detail_ViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2021/3/15.
//  Copyright © 2021 junye lu. All rights reserved.
//

import UIKit
import Photos
import SwiftyJSON
import LGButton

protocol DZSH_Detail_ViewController_Delegate {
    func DZSH_Detail_ViewController_refresh()
}
class DZSH_Detail_ViewController: BaseViewController,UITableViewDelegate,UITableViewDataSource, GeliAlertTextViewDelegate ,DZSH_Two_Btn_Cell_Delegate, Location_Cell_Delegate, DZSH_UPLOAD_IMG_CELL_Delegate, UIPickerViewDataSource, UIPickerViewDelegate, DZSH_Date_Cell_Delegate, GLAlertSelectViewDelegate, OnlyTimeSelectView_Delegate,DZSH_Upload_Cer_Cell_Delegate, TitleAndTFCellDelegate, CLLocationManagerDelegate{
    
    @IBOutlet weak var btm_title_lbl: UILabel!
    var delegate:DZSH_Detail_ViewController_Delegate?
    
    @IBOutlet weak var btm_h: NSLayoutConstraint!
    var shop_id = -1
    var user_token = ""
    
    var part0 = ["是否清真","用户类型","店铺类型",""]
    var is_qz = false
    var kd = false
    var shop_type = 0//类型
    var type_arr:Array<shop_type_model> = []
    var shop_longitude = ""
    var shop_latitude = ""
    
    var part1 = ["公司名称","公司简称","关联专区展示","公司所在地","公司详细地址"]
    var shop_name = ""//公司名
    
    var adr_str = ""//地址
    var show_abbre = true//显示简称 1是 0否
    var abbreviation = ""//简称1
    var sparea_ids = ""//关联专区
    var sparea_select = -1
    
    
    var is_logo = true
    var logo_word = ""//简称2
    
    var business_week_start = 1
    var business_week_end = 5
    
    var pickup_start_day = 1
    var pickup_end_day = 5
    
    var shop_img = ""//logo连接
    
    var part2 = ["自提时间","联系电话","自提地址"]
    var pickup_phone = ""//联系人选择
    var pickup_address = ""//自提地址
    
    var part3 = ["公司电话","公司规模","公司简介","联系人姓名","电子邮箱"]
    var shop_scale = ""//规模
    var shop_tel = ""//公司电话
    var shop_intro = ""//公司简介
    var contacts_name = "" //联系人
    var shop_email = ""//电子邮箱
    
    var shops_sparea:Array<shops_sparea_model> = []
    
    var part4 = ["营业执照号","法定经营范围","负责人身份证","入驻协议","营业执照电子版","流通许可证"]
    var business_licence_number = ""//执照号
    var identity_card_front = ""//联系人身份证连接
    var business_sphere = ""//经营范围
    var zhizhao = ""//营业执照连接
    var food_production_license = ""//流通许可连接
    
    var agreement = ""//入驻连接
    
    var type = -1
    var action = -1 //1为审核通过，2为审核不通过，3为审核通过待补齐资料
    var manger:CLLocationManager = CLLocationManager()
    func locationManager(_ manager: CLLocationManager, didUpdateLocations locations: [CLLocation]) {
        manger.stopUpdatingLocation()
        let location = locations.last
        let coo = JZLocationConverter.wgs84(toGcj02: CLLocationCoordinate2D(latitude: (location?.coordinate.latitude)!, longitude: (location?.coordinate.longitude)!))
        shop_latitude = "\(coo.latitude)"
        shop_longitude = "\(coo.longitude)"
        list_view.reloadData()
    }
    
    var business_hours = "09:00-18:00"
    var pickup_hours = "09:00-18:00"
    func OnlyTimeSelectView_submitAction(view: OnlyTimeSelectView, sh: Int, sm: Int, eh: Int, em: Int) {
        timeSelect_view!.removeFromSuperview()
        timeSelect_view = nil
        var s1 = StringByInt(number: sh)
        if s1.count == 1 {
            s1 = "0" + StringByInt(number: sh)
        }
        
        var s2 = StringByInt(number: sm)
        if s2.count == 1 {
            s2 = "0" + StringByInt(number: sm)
        }
        
        var s3 = StringByInt(number: eh)
        if s3.count == 1 {
            s3 = "0" + StringByInt(number: eh)
        }
        
        var s4 = StringByInt(number: em)
        if s4.count == 1 {
            s4 = "0" + StringByInt(number: em)
        }
        if view.tag == 99 {//营业时间
            business_hours = s1 + ":" + s2 + "-" + s3 + ":" + s4
        }else{
            pickup_hours = s1 + ":" + s2 + "-" + s3 + ":" + s4
        }
        
        list_view.reloadData()
    }
    
    func GLASClose(view: GLAlertSelectView, selectnum: Int, selectArr: Array<Int>) {
        view.removeFromSuperview()
        glSelectView = nil
    }
    
    func GLAlertSelectViewClick(selectNum: Int, view: GLAlertSelectView) {
        print(view.tag)
        switch view.tag {
        case 0:
            shop_type = selectNum
            break
        case 12:
            sparea_select = selectNum
            if sparea_select != -1 && sparea_select != 10086 {
                sparea_ids = shops_sparea[sparea_select].sparea_name!
            }else{
                sparea_ids = ""
            }
            
            break
        case 22:
            business_week_start = selectNum
            break
        case 23:
            business_week_end = selectNum
            break
        case 30:
            pickup_start_day = selectNum
            break
        case 31:
            pickup_end_day = selectNum
        default:
            break
        }
        list_view.reloadData()
        view.removeFromSuperview()
        glSelectView = nil
    }
    
    var date_arr = ["星期一","星期二","星期三","星期四","星期五","星期六","星期天"]
    var glSelectView:GLAlertSelectView?
    
    
    var timeSelect_view:OnlyTimeSelectView?
    func DZSH_Date_Cell_SelectAction(sender: UIButton, cell: DZSH_Date_Cell) {
        
        switch sender.tag {
        case 0:
            if glSelectView == nil {
                let view = GLAlertSelectView(frame: self.view.bounds)
                view.tag = cell.tag
                view.titleLbl.text = "请选择日期"
                view.delegate = self
                view.dataArr = date_arr
                view.is_center_select = true
                if cell.tag < 30 {
                    view.selectNum = business_week_start
                }else{
                    view.selectNum = pickup_start_day
                }
                self.view.addSubview(view)
                glSelectView = view
            }
            break
        case 1:
            if glSelectView == nil {
                let view = GLAlertSelectView(frame: self.view.bounds)
                view.tag = cell.tag + 1
                view.titleLbl.text = "请选择日期"
                view.delegate = self
                view.dataArr = date_arr
                view.is_center_select = true
                if cell.tag < 30 {
                    view.selectNum = business_week_end
                }else{
                    view.selectNum = pickup_end_day
                }
                self.view.addSubview(view)
                glSelectView = view
            }
            break
        default:
            if timeSelect_view == nil {
                let view = OnlyTimeSelectView(frame: self.view.bounds)
                view.tag = 99
                if cell.tag == 30 {
                    view.tag = 100
                }
                view.delegate = self
                view.titleStr = (sender.titleLabel?.text)!
                self.view.addSubview(view)
                timeSelect_view = view
            }
            break
        }
    }
    func DZSH_UPLOAD_IMG_CELL_SelectImg(cell: DZSH_UPLOAD_IMG_CELL) {
        print(cell.tag)
        selectUpLoadImg(tag: cell.tag)
        
    }
    func DZSH_UPLOAD_IMG_CELL_Input(str: String, cell: DZSH_UPLOAD_IMG_CELL) {
        if cell.tag == 11 {
            abbreviation = str
        }
        if cell.tag == 21 {//公司简称/logo
            logo_word = str
        }
    }
    
    func DZSH_UPLOAD_IMG_CELL_Btn_Action(select: Int, cell: DZSH_UPLOAD_IMG_CELL) {
        if cell.tag == 11 {
            show_abbre = false
            if select == 1 {
                show_abbre = true
            }
        }
        
        if cell.tag == 21 {//公司简称/logo
            is_logo = true
            if select == 0 {
                is_logo = false
            }
        }
        list_view.reloadData()
    }
    
    func Location_Cell_action() {
        print("获取lat,lng")
        manger.startUpdatingLocation()
    }
    
    func Location_Cell_input_tf(idx: Int, str: String) {
        if idx == 0 {
            shop_latitude = str
        }else{
            shop_longitude = str
        }
    }
    
    func DZSH_Two_Btn_Cell_Click_Action(select: Int, cell: DZSH_Two_Btn_Cell) {
        if cell.tag == 0 {
            is_qz = false
            if select == 1 {
                is_qz = true
            }
        }else{
            kd = false
            if select == 1 {
                kd = true
            }
        }
    }
    
    
    @IBAction func submit_action(_ sender: Any) {
        if title_str == "店铺信息" {
            var qz = 1
            if is_qz == false {
                qz = 0
            }
            var k = 1
            if kd == false {
                k = 0
            }
            
            var show_name = 0
            if show_abbre {
                show_name = 1
            }
            var show_logo = 0
            if is_logo {
                show_logo = 1
            }
            let proDict = addressArray[provinceIndex] as! Dictionary<String,Any>
            var cityDict:Dictionary<String,Any> = Dictionary()
            var areaDict:Dictionary<String,Any> = Dictionary()
            cityDict["area_id"] = ""
            areaDict["area_id"] = ""
            if (proDict["city_list"] as! NSArray).count > 0 {
                cityDict = (proDict["city_list"] as! NSArray)[cityIndex] as! Dictionary<String, Any>
                if (cityDict["district_list"] as! NSArray).count > 0 {
                    areaDict = (cityDict["district_list"] as! NSArray)[areaIndex] as! Dictionary<String,Any>
                }
            }
            
            let shops = [
                "is_qz":qz as Any,
                "kd":k as Any,
                "shop_type":type_arr[shop_type].shop_type as Any,
                "shop_longitude":shop_longitude as Any,
                "shop_latitude":shop_latitude as Any,
                "shop_name":shop_name as Any,
                "show_abbre":show_name as Any,
                "abbreviation":abbreviation as Any,
                "sparea_ids":sparea_ids as Any,
                "province":proDict["area_id"] as Any,
                "city":cityDict["area_id"] as Any,
                "district":areaDict["area_id"] as Any,
                "address":adr_str as Any,
                "is_logo":show_logo as Any,
                "shop_img":shop_img as Any,
                "logo_word":logo_word as Any,
                "business_week_start":business_week_start + 1 as Any,
                "business_week_end":business_week_end + 1 as Any,
                "business_hours":business_hours as Any,
                "pickup_start_day":pickup_start_day + 1 as Any,
                "pickup_end_day":pickup_end_day + 1 as Any,
                "pickup_hours":pickup_hours as Any,
                "pickup_phone":pickup_phone as Any,
                "pickup_address":pickup_address as Any,
                "shop_tel":shop_tel as Any,
                "shop_scale":shop_scale as Any,
                "shop_intro":shop_intro as Any,
                "contacts_name":contacts_name as Any,
                "shop_email":shop_email as Any,
                "business_licence_number":business_licence_number as Any,
                "business_sphere":business_sphere as Any,
                "identity_card_front":identity_card_front as Any,
                "agreement":agreement as Any,
                "zhizhao":zhizhao as Any,
                "food_production_license":food_production_license as Any,
                "shop_id":shop_id as Any
            ]
            
            let shops_info = dictChangeString(sender:shops)
            let dic = ["user_token":user_token as Any,
                       "action":action as Any,
                       "shop_id":shop_id as Any,
                       "vendor_audit_desc":"" as Any,
                       "reason":"" as Any,
                       "shop_info":shops_info as Any]
                storeExamineOperation(dic) { (data) in
                    HUD.flash(.success, delay: 1.2)
                    self.navigationController?.popViewController(animated: true)
                    self.delegate?.DZSH_Detail_ViewController_refresh()
                } failture: { (err) in
                    
                }
            
            return
        }
        let alterView = GeliAlertTextView(frame: self.view.window!.bounds)
        alterView.delegate = self
        alterView.tag = 99
        self.view.window?.addSubview(alterView)
        action = 1
        alterView.titleLbl.text = "请填写通过原因"
        alterView.placerLbl.text = "请填写通过原因"
    }
    //view
    @IBOutlet weak var btm_action_view: UIView!
    @IBOutlet weak var btm_action_bg: UIView!
    
    @IBOutlet weak var list_view: UITableView!
    @IBAction func btm_action(_ sender: UIButton) {
        let alterView = GeliAlertTextView(frame: self.view.window!.bounds)
        alterView.delegate = self
        alterView.tag = 99
        self.view.window?.addSubview(alterView)
        switch sender.tag {
        case 0://通过
            action = 1
            alterView.titleLbl.text = "请填写通过原因"
            alterView.placerLbl.text = "请填写通过原因"
            break
        case 1://补资料
            action = 3
            alterView.titleLbl.text = "请填写需要补充的资料"
            alterView.placerLbl.text = "请填写需要补充的资料"
            break
        default://不通过
            action = 2
            alterView.tag = 992
            alterView.titleLbl.text = "请填写不通过原因"
            alterView.placerLbl.text = "请填写不通过原因(必填)"
            break
        }
    }
    
    var title_str = ""
    
    @IBOutlet weak var save_btn: LGButton!
    var hourArr:Array<String> = []
    @IBOutlet weak var lbl_top: NSLayoutConstraint!
    var minArr:Array<String> = []
    override func viewDidLoad() {
        super.viewDidLoad()
        //        navbar.title = "信息审核"
        
        manger.delegate = self
        manger.requestAlwaysAuthorization()
        manger.requestWhenInUseAuthorization()
        
        if title_str == "店铺信息" {
            action = 4
            btm_action_view.removeFromSuperview()
            btm_action_bg.removeFromSuperview()
        }else{
            if type == 2 {//已审核
                btm_action_view.removeFromSuperview()
                btm_action_bg.removeFromSuperview()
                action = 4
                if action != 3 {
                    btm_h.constant = 0
                    lbl_top.constant = 0
                    btm_title_lbl.isHidden = true
                    save_btn.isHidden = true
                }
            }
        }
        print("action === ",action)
        hourArr.removeAll()
        minArr.removeAll()
        
        for i in 0 ..< 24 {
            hourArr.append(StringByInt(number: i))
        }
        for i in 0 ..< 60 {
            minArr.append(StringByInt(number: i))
        }
        
        navbar.title = title_str
        if title_str == "信息审核" {
            btm_action_bg.isHidden = false
            btm_action_view.isHidden = false
        }
        self.view.addSubview(navbar)
        SetTopFrameView(view: list_view, btmView: self.view)
        
        list_view.separatorStyle = .none
        list_view.register(UINib(nibName: "TitleAndTFCell", bundle: nil), forCellReuseIdentifier: "TitleAndTFCell")
        list_view.register(UINib(nibName: "DZSH_Date_Cell", bundle: nil), forCellReuseIdentifier: "DZSH_Date_Cell")
        list_view.register(UINib(nibName: "TitleAndLblCell", bundle: nil), forCellReuseIdentifier: "TitleAndLblCell")
        
        list_view.register(UINib(nibName: "TitleAndBtnCell", bundle: nil), forCellReuseIdentifier: "TitleAndBtnCell")
        list_view.register(UINib(nibName: "DZSH_UPLOAD_IMG_CELL", bundle: nil), forCellReuseIdentifier: "DZSH_UPLOAD_IMG_CELL")
        list_view.register(UINib(nibName: "DZSH_Upload_Cer_Cell", bundle: nil), forCellReuseIdentifier: "DZSH_Upload_Cer_Cell")
        
        list_view.register(UINib(nibName: "DZSH_Two_Btn_Cell", bundle: nil), forCellReuseIdentifier: "DZSH_Two_Btn_Cell")
        
        list_view.register(UINib(nibName: "Location_Cell", bundle: nil), forCellReuseIdentifier: "Location_Cell")
        
        
        storeInfo(["user_token":user_token as Any,"shop_id":shop_id as Any]) {[self] (data) in
            
            let dataModel = data as! storeInfo_model
            let model = dataModel.data
            type_arr.removeAll()
            model?.shop_type?.forEach({ (item) in
                type_arr.append(item)
            })
            
            for i in 0 ..< type_arr.count{
                if (model?.shop_info?.shop_type)! == type_arr[i].shop_type {
                    shop_type = i
                }
            }
            
            is_qz = true
            if model?.shop_info?.is_qz == 0 {
                is_qz = false
            }
            kd = true
            if model?.shop_info?.kd == 0 {
                kd = false
            }
            
            shop_longitude = (model?.shop_info?.shop_longitude)!
            shop_longitude = (model?.shop_info?.shop_latitude)!
            shop_name = (model?.shop_info?.shop_name)!
            show_abbre = false
            if model?.shop_info?.show_abbre == 1 {
                show_abbre = true
            }
            abbreviation = (model?.shop_info?.abbreviation)!
            logo_word = (model?.shop_info?.logo_word)!
            sparea_ids = (model?.shop_info?.sparea_ids)!
            provinceIndex = (model?.shop_info?.province)!
            cityIndex = (model?.shop_info?.city)!
            areaIndex = (model?.shop_info?.district)!
            adr_str = (model?.shop_info?.address)!
            is_logo = true
            if model?.shop_info?.is_logo == 0 {
                is_logo = false
            }
            shop_img = (model?.shop_info?.shop_img)!
            logo_word = (model?.shop_info?.logo_word)!
            business_week_start = (model?.shop_info?.business_week_start)!-1
            if business_week_start < 0 {
                business_week_start = 1
            }
            business_week_end = (model?.shop_info?.business_week_end)!-1
            if business_week_end < 0 {
                business_week_end = 5
            }
            business_hours = (model?.shop_info?.business_hours)!
            if business_hours.count == 0 {
                business_hours = "09:00-18:00"
            }
            pickup_start_day = (model?.shop_info?.pickup_start_day)!-1
            if pickup_start_day < 0 {
                pickup_start_day = 1
            }
            pickup_end_day = (model?.shop_info?.pickup_end_day)!-1
            if pickup_end_day < 0 {
                pickup_end_day = 5
            }
            pickup_hours = (model?.shop_info?.pickup_hours)!
            if pickup_hours.count == 0 {
                pickup_hours = "09:00-18:00"
            }
            
            pickup_phone = (model?.shop_info?.pickup_phone)!
            pickup_address = (model?.shop_info?.pickup_address)!
            
            shop_tel = (model?.shop_info?.shop_tel)!
            shop_scale = (model?.shop_info?.shop_scale)!
            shop_intro = (model?.shop_info?.shop_intro)!
            
            contacts_name = (model?.shop_info?.contacts_name)!
            shop_email = (model?.shop_info?.shop_email)!
            business_licence_number = (model?.shop_info?.business_licence_number)!
            business_sphere = (model?.shop_info?.business_sphere)!
            
            identity_card_front = (model?.shop_info?.identity_card_front)!
            agreement = (model?.shop_info?.agreement)!
            zhizhao = (model?.shop_info?.zhizhao)!
            
            food_production_license = (model?.shop_info?.food_production_license)!
            
            shops_sparea.removeAll()
            model?.shops_sparea?.forEach({ (item) in
                shops_sparea.append(item)
            })
            
            
            for i in 0 ..< shops_sparea.count {
                if model?.shop_info?.sparea_ids == shops_sparea[i].sparea_name {
                    sparea_select = i
                }
            }
            
            getIndex()
            list_view.reloadData()
            
        } failture: { (err ) in
            
        }
        
    }
    
    //MARK: - tableviewdelegate
    func numberOfSections(in tableView: UITableView) -> Int {
        return 6
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        switch section {
        case 0:
            return 4
        case 1:
            return 5
        case 2:
            return 2
        case 3:
            return 3
        case 4:
            return 5
        default:
            return 6
        }
    }
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        
        switch indexPath.section {
        case 0:
            if indexPath.row == 3 {
                return 132.5
            }
            break
        case 1:
            if indexPath.row == 1 {
                if show_abbre {
                    return 95
                }
            }
        case 2:
            if indexPath.row == 0 {
                if is_logo {
                    return 237
                }else{
                    return 95
                }
            }
            return 100
        case 3:
            if indexPath.row == 0 {
                return 100
            }
        case 4:
            if indexPath.row == 2 {
                return UITableView.automaticDimension
            }
        case 5:
            if indexPath.row > 1 {
                return 183.5
            }
        default:
            break
        }
        return 49
        
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        
        switch indexPath.section {
        case 0:
            switch indexPath.row {
            case 0,1:
                let cell = tableView.dequeueReusableCell(withIdentifier: "DZSH_Two_Btn_Cell") as! DZSH_Two_Btn_Cell
                cell.nameLbl.text = part0[indexPath.row]
                cell.tag = indexPath.row
                cell.delegate = self
                if indexPath.row == 0 {
                    cell.leftBtn.setTitle(" 是", for: .normal)
                    cell.rightBtn.setTitle(" 否", for: .normal)
                    
                    if is_qz {
                        cell.leftBtn.isSelected = true
                        cell.rightBtn.isSelected = false
                    }else{
                        cell.leftBtn.isSelected = false
                        cell.rightBtn.isSelected = true
                    }
                }else{
                    cell.leftBtn.setTitle(" 企业", for: .normal)
                    cell.rightBtn.setTitle(" 个人", for: .normal)
                    if kd {
                        cell.leftBtn.isSelected = true
                        cell.rightBtn.isSelected = false
                    }else{
                        cell.leftBtn.isSelected = false
                        cell.rightBtn.isSelected = true
                    }
                }
                return cell
            case 2:
                let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndBtnCell") as! TitleAndBtnCell
                cell.nameLbl.text = part0[indexPath.row]
                print("sjp[ = ",shop_type)
                if type_arr.count > 0 {
                    let mo = type_arr[shop_type]
                    cell.contentLbl.text = mo.type_name
                }
                cell.btn.isUserInteractionEnabled = false
                return cell
            default:
                let cell = tableView.dequeueReusableCell(withIdentifier: "Location_Cell") as! Location_Cell
                cell.delegate = self
                cell.lng_tf.text = shop_longitude
                cell.lat_tf.text = shop_latitude
                return cell
            }
        case 1:
            switch indexPath.row {
            case 1:
                let cell = tableView.dequeueReusableCell(withIdentifier: "DZSH_UPLOAD_IMG_CELL") as! DZSH_UPLOAD_IMG_CELL
                cell.tag = 11
                cell.delegate = self
                cell.nameLbl.text = part1[indexPath.row]
                cell.bottom_lbl.isHidden = true
                cell.img_view.isHidden = true
                cell.input_tf.isHidden = false
                cell.leftBtn.setTitle(" 显示", for: .normal)
                cell.rightBtn.setTitle(" 隐藏", for: .normal)
                cell.titleLbl.text = "公司简称"
                cell.leftBtn.isSelected = false
                cell.rightBtn.isSelected = true
                if show_abbre {
                    cell.leftBtn.isSelected = true
                    cell.rightBtn.isSelected = false
                }
                cell.input_tf.placeholder = "请输入公司简称"
                cell.input_tf.text = abbreviation
                return cell
            case 2:
                let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndBtnCell") as! TitleAndBtnCell
                cell.nameLbl.text = part1[indexPath.row]
                cell.contentLbl.text = sparea_ids
                cell.btn.isUserInteractionEnabled = false
                return cell
            default:
                break
            }
            let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndTFCell") as! TitleAndTFCell
            cell.delegate = self
            cell.tag = indexPath.row + 10
            cell.nameLbl.text = part1[indexPath.row]
            cell.textTF.isUserInteractionEnabled = true
            
            if indexPath.row == 3{
                cell.textTF.isUserInteractionEnabled = false
                cell.textTF.placeholder = "请选择城市"
                cell.textTF.text = dzStr
            }else{
                if indexPath.row == 0 {
                    cell.textTF.placeholder = "等待填写"
                    cell.textTF.text = shop_name
                }else{
                    cell.textTF.placeholder = "等待填写"
                    cell.textTF.text = adr_str
                }
            }
            return cell
        case 2:
            if indexPath.row == 0 {
                let cell = tableView.dequeueReusableCell(withIdentifier: "DZSH_UPLOAD_IMG_CELL") as! DZSH_UPLOAD_IMG_CELL
                cell.tag = 21
                cell.delegate = self
                cell.nameLbl.text = part1[indexPath.row]
                cell.bottom_lbl.isHidden = true
                cell.img_view.isHidden = true
                cell.input_tf.isHidden = false
                cell.leftBtn.setTitle(" logo", for: .normal)
                cell.rightBtn.setTitle(" 简称", for: .normal)
                cell.leftBtn.isSelected = false
                cell.rightBtn.isSelected = true
                cell.titleLbl.text = "店铺简称"
                if is_logo {
                    cell.titleLbl.text = "店铺logo"
                    cell.leftBtn.isSelected = true
                    cell.rightBtn.isSelected = false
                    cell.input_tf.isHidden = true
                    cell.bottom_lbl.isHidden = false
                    cell.img_view.isHidden = false
                    if shop_img.count > 0 {
                        cell.img_view?.sd_setImage(with: URL(string:SERVERCE_ImageHost + shop_img), placeholderImage: nil,options:.allowInvalidSSLCertificates)
                    }else{
                        cell.img_view.image = UIImage(named: "shangchuantupian")
                    }
                }
                cell.input_tf.placeholder = "请输入店铺简称"
                cell.input_tf.text = logo_word
                return cell
            }
            if indexPath.row == 1 {
                let cell = tableView.dequeueReusableCell(withIdentifier: "DZSH_Date_Cell") as! DZSH_Date_Cell
                cell.nameLbl.text = "营业信息"
                cell.tag = 22
                cell.delegate = self
                cell.indexPath = indexPath
                cell.startDateLbl.text = date_arr[business_week_start]
                cell.endDateLbl.text = date_arr[business_week_end]
                cell.timeLbl.text = business_hours
                return cell
            }
        case 3:
            if indexPath.row == 0 {
                let cell = tableView.dequeueReusableCell(withIdentifier: "DZSH_Date_Cell") as! DZSH_Date_Cell
                cell.nameLbl.text = part2[indexPath.row]
                cell.tag = 30
                cell.delegate = self
                cell.indexPath = indexPath
                cell.startDateLbl.text = date_arr[pickup_start_day]
                cell.endDateLbl.text = date_arr[pickup_end_day]
                cell.timeLbl.text = pickup_hours
                return cell
            }
            let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndTFCell") as! TitleAndTFCell
            cell.tag = indexPath.row + 30
            cell.delegate = self
            cell.textTF.placeholder = "等待填写"
            cell.textTF.isUserInteractionEnabled = true
            cell.nameLbl.text = part2[indexPath.row]
            switch indexPath.row {
            case 1:
                cell.textTF.text = pickup_phone
                break
            case 2:
                cell.textTF.text = pickup_address
                break
            default:
                break
            }
            return cell
        case 4:
            if indexPath.row == 2 {
                let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndLblCell") as! TitleAndLblCell
                cell.imgRight.constant = 0
                cell.nameLbl.text = part3[indexPath.row]
                if shop_intro.count == 0 {
                    cell.contentLbl.text = "等待填写"
                    cell.contentLbl.textColor = UIColor(named: "提示语字体颜色")
                }else{
                    cell.contentLbl.text = shop_intro
                    cell.contentLbl.textColor = UIColor(named: "标题字颜色")
                }
                return cell
            }
            let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndTFCell") as! TitleAndTFCell
            cell.delegate = self
            cell.tag = indexPath.row + 40
            cell.textTF.isUserInteractionEnabled = true
            cell.textTF.placeholder = "等待填写"
            cell.nameLbl.text = part3[indexPath.row]
            switch indexPath.row {
            case 0:
                cell.textTF.text = shop_tel
                break
            case 1:
                cell.textTF.text = shop_scale
                break
            case 3:
                cell.textTF.text = contacts_name
                break
            case 4:
                cell.textTF.text = shop_email
                break
            default:
                break
            }
            return cell
        case 5:
            if indexPath.row > 1 {
                let cell = tableView.dequeueReusableCell(withIdentifier: "DZSH_Upload_Cer_Cell") as! DZSH_Upload_Cer_Cell
                cell.tag = indexPath.row + 50
                cell.delegate = self
                cell.nameLbl.text = part4[indexPath.row]
                
                switch indexPath.row {
                case 2:
                    if (identity_card_front.count > 0) {
                        cell.img_view?.sd_setImage(with: URL(string:SERVERCE_ImageHost + identity_card_front), placeholderImage: nil,options:.allowInvalidSSLCertificates)
                    }else{
                        cell.img_view.image = UIImage(named: "upload_1")
                    }
                    break
                case 3:
                    if agreement.count > 0 {
                        cell.img_view?.sd_setImage(with: URL(string:SERVERCE_ImageHost + agreement), placeholderImage: nil,options:.allowInvalidSSLCertificates)
                    }else{
                        cell.img_view.image = UIImage(named: "upload_1")
                    }
                    break
                case 4:
                    if zhizhao.count > 0 {
                        cell.img_view?.sd_setImage(with: URL(string:SERVERCE_ImageHost + zhizhao), placeholderImage: nil,options:.allowInvalidSSLCertificates)
                    }else{
                        cell.img_view.image = UIImage(named: "upload_1")
                    }
                    break
                default:
                    if food_production_license.count > 0 {
                        cell.img_view?.sd_setImage(with: URL(string:SERVERCE_ImageHost + food_production_license), placeholderImage: nil,options:.allowInvalidSSLCertificates)
                    }else{
                        cell.img_view.image = UIImage(named: "upload_1")
                    }
                    break
                }
                return cell
            }
            let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndTFCell") as! TitleAndTFCell
            cell.delegate = self
            cell.tag = indexPath.row + 50
            cell.textTF.placeholder = "等待填写"
            cell.textTF.isUserInteractionEnabled = true
            cell.nameLbl.text = part4[indexPath.row]
            if indexPath.row == 0 {
                cell.textTF.text = business_licence_number
            }else{
                cell.textTF.text = business_sphere
            }
            
            return cell
        default:
            break
        }
        
        let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndTFCell") as! TitleAndTFCell
        return cell
    }
    
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        
        switch indexPath.section {
        case 0:
            if indexPath.row == 2 {
                if glSelectView == nil {
                    let view = GLAlertSelectView(frame: self.view.bounds)
                    view.tag = 0
                    view.titleLbl.text = "请选择店铺类型"
                    view.delegate = self
                    var arr:Array<String> = []
                    type_arr.forEach { (item) in
                        arr.append(item.type_name!)
                    }
                    view.dataArr = arr
                    view.is_center_select = true
                    view.selectNum = shop_type
                    self.view.addSubview(view)
                    glSelectView = view
                }
            }
            break
        case 1:
            if indexPath.row == 2 {
                if glSelectView == nil {
                    let view = GLAlertSelectView(frame: self.view.bounds)
                    view.tag = 12
                    view.titleLbl.text = "请选择关联专区"
                    view.delegate = self
                    view.isBz = true
                    var arr:Array<String> = []
                    shops_sparea.forEach { (item) in
                        arr.append(item.sparea_name!)
                    }
                    view.dataArr = arr
                    view.is_center_select = true
                    if sparea_select != -1 && sparea_select != 10086 {
                        view.selectNum = sparea_select
                    }
                    self.view.addSubview(view)
                    glSelectView = view
                }
            }
            if indexPath.row == 3 {
                print_bottom_cell_select_place_action()
            }
            break
        case 4:
            if indexPath.row == 2 {
                let alterView = GeliAlertTextView(frame: self.view.window!.bounds)
                alterView.tag = 4
                alterView.delegate = self
                alterView.titleLbl.text = "请填写公司简介"
                alterView.placerLbl.text = "请填写公司简介..."
                alterView.content = shop_intro
                self.view.window?.addSubview(alterView)
            }
        default:
            break
        }
    }
    
    func selectUpLoadImg(tag:Int){
        _ = self.presentHGImagePicker(maxSelected:1) { (assets) in
            //结果处理
            print("共选择了\(assets.count)张图片，分别如下：")
            let option = PHImageRequestOptions()
            option.isSynchronous = true
            option.isNetworkAccessAllowed = true
            for asset in assets {
                PHImageManager.default().requestImage(for: asset, targetSize: PHImageManagerMaximumSize , contentMode:  .default , options: option, resultHandler: { (image,  _: [AnyHashable : Any]?) in
                    //                    print("上传图片==\(image)")
                    self.uploadImg(imge: image!, isOriginal: true, tag: tag)
                })
            }
            self.list_view.reloadData()
        }
    }
    //MARK: - 不通过原因
    func sureGeliAlertTextViewAction(sender: String, view: GeliAlertTextView) {
        
        var qz = 1
        if is_qz == false {
            qz = 0
        }
        var k = 1
        if kd == false {
            k = 0
        }
        
        var show_name = 0
        if show_abbre {
            show_name = 1
        }
        var show_logo = 0
        if is_logo {
            show_logo = 1
        }
        let proDict = addressArray[provinceIndex] as! Dictionary<String,Any>
        var cityDict:Dictionary<String,Any> = Dictionary()
        var areaDict:Dictionary<String,Any> = Dictionary()
        cityDict["area_id"] = ""
        areaDict["area_id"] = ""
        if (proDict["city_list"] as! NSArray).count > 0 {
            cityDict = (proDict["city_list"] as! NSArray)[cityIndex] as! Dictionary<String, Any>
            if (cityDict["district_list"] as! NSArray).count > 0 {
                areaDict = (cityDict["district_list"] as! NSArray)[areaIndex] as! Dictionary<String,Any>
            }
        }
        
        let shops = [
            "is_qz":qz as Any,
            "kd":k as Any,
            "shop_type":type_arr[shop_type].shop_type as Any,
            "shop_longitude":shop_longitude as Any,
            "shop_latitude":shop_latitude as Any,
            "shop_name":shop_name as Any,
            "show_abbre":show_name as Any,
            "abbreviation":abbreviation as Any,
            "sparea_ids":sparea_ids as Any,
            "province":proDict["area_id"] as Any,
            "city":cityDict["area_id"] as Any,
            "district":areaDict["area_id"] as Any,
            "address":adr_str as Any,
            "is_logo":show_logo as Any,
            "shop_img":shop_img as Any,
            "logo_word":logo_word as Any,
            "business_week_start":business_week_start + 1 as Any,
            "business_week_end":business_week_end + 1 as Any,
            "business_hours":business_hours as Any,
            "pickup_start_day":pickup_start_day + 1 as Any,
            "pickup_end_day":pickup_end_day + 1 as Any,
            "pickup_hours":pickup_hours as Any,
            "pickup_phone":pickup_phone as Any,
            "pickup_address":pickup_address as Any,
            "shop_tel":shop_tel as Any,
            "shop_scale":shop_scale as Any,
            "shop_intro":shop_intro as Any,
            "contacts_name":contacts_name as Any,
            "shop_email":shop_email as Any,
            "business_licence_number":business_licence_number as Any,
            "business_sphere":business_sphere as Any,
            "identity_card_front":identity_card_front as Any,
            "agreement":agreement as Any,
            "zhizhao":zhizhao as Any,
            "food_production_license":food_production_license as Any,
            "shop_id":shop_id as Any
        ]
        
        let shops_info = dictChangeString(sender:shops)
        let dic = ["user_token":user_token as Any,
                   "action":action as Any,
                   "shop_id":shop_id as Any,
                   "vendor_audit_desc":sender as Any,
                   "reason":sender as Any,
                   "shop_info":shops_info as Any]
        
        switch view.tag {
        case 99://通过，补齐资料
            storeExamineOperation(dic) { (data) in
                HUD.flash(.success, delay: 1.2)
                self.navigationController?.popViewController(animated: true)
                self.delegate?.DZSH_Detail_ViewController_refresh()
            } failture: { (err) in
                
            }
            return
        case 992://不通过原因
            if sender.count == 0 {
                HUD.flash(.label("请填写不通过原因"), delay: 1.2)
                return
            }
            storeExamineOperation(dic) { (data) in
                
            } failture: { (err) in
                
            }
            return
        case 4://公司简介
            shop_intro = sender
            break
        default:
            break
        }
        list_view.reloadData()
    }
    
    func uploadImg (imge:UIImage,isOriginal:Bool,tag:Int){
        
        let upLoadImg = imge as! UIImage
        HUD.show(.progress)
        saveFile(image: upLoadImg, ["user_token":user_token as Any,"path":"shops" as Any], success: { (data) in
            let dataM = data as! SaveFileModel
            if dataM.code == 1 {
                print("图片上传成功\(dataM.data?.url)")
                switch tag {
                case 21:
                    self.shop_img = (dataM.data?.url)!
                    break
                case 52:
                    self.identity_card_front = (dataM.data?.url)!
                    break
                case 53:
                    self.agreement = (dataM.data?.url)!
                    break
                case 54:
                    self.zhizhao = (dataM.data?.url)!
                    break
                case 55:
                    self.food_production_license = (dataM.data?.url)!
                    break
                default:
                    break
                }
                self.list_view.reloadData()
                HUD.hide()
            }
            
        }) { (error) in
            print("图片上传失败\(error)")
        }
        
    }
    
    func tableView(_ tableView: UITableView, viewForHeaderInSection section: Int) -> UIView? {
        if section == 3 {
            let view = UIView(frame: CGRect(x: 0, y: 0, width: ScreenWidth, height: 36))
            view.backgroundColor = UIColor.white
            let lbl = UILabel(frame: CGRect(x: 15, y: 15, width: 100, height: 15))
            lbl.text = "自提信息"
            lbl.textColor = UIColor(named: "标题字颜色")
            lbl.font = UIFont(name: "PingFangSC-Medium", size: 15)
            view.addSubview(lbl)
            return view
        }
        return UIView()
    }
    func tableView(_ tableView: UITableView, heightForHeaderInSection section: Int) -> CGFloat {
        if section == 3 {
            return 36
        }
        return 0.000001
    }
    
    func tableView(_ tableView: UITableView, viewForFooterInSection section: Int) -> UIView? {
        return UIView()
    }
    func tableView(_ tableView: UITableView, heightForFooterInSection section: Int) -> CGFloat {
        return 5
    }
    //MARK:--地址选择器
    func showAreaSelect(view:UIView){
        //创建选择器
        
        pickerView=UIPickerView()
        //将dataSource设置成自己
        pickerView.dataSource=self
        //将delegate设置成自己
        pickerView.delegate=self
        view.addSubview(pickerView)
        pickerView.snp.makeConstraints { (make) in
            make.top.equalTo(30)
            make.left.right.bottom.equalTo(0)
        }
        pickerView.selectRow(provinceIndex, inComponent: 0, animated: false)
        pickerView(pickerView, didSelectRow: provinceIndex, inComponent: 0)
        pickerView.selectRow(cityIndex, inComponent: 1, animated: false)
        pickerView(pickerView, didSelectRow: cityIndex, inComponent: 1)
        pickerView.selectRow(areaIndex, inComponent: 2, animated: false)
        pickerView(pickerView, didSelectRow: areaIndex, inComponent: 2)
        
        
    }
    var btmView:UIView?
    var bgBtn:UIButton?
    @objc func closeAction(sender:UIButton){
        bgBtn?.removeFromSuperview()
        btmView?.subviews.forEach({ (view) in
            view.removeFromSuperview()
        })
        btmView?.removeFromSuperview()
        btmView = nil
        bgBtn = nil
    }
    
    func print_bottom_cell_select_place_action() {
        print("地址选择")
        if bgBtn == nil {
            let btn = UIButton()
            self.view.addSubview(btn)
            btn.backgroundColor = UIColor.black
            btn.alpha = 0.4
            btn.addTarget(self, action: #selector(closeAction(sender:)), for: .touchUpInside)
            btn.snp.makeConstraints { (make) in
                make.top.right.bottom.left.equalTo(0)
            }
            bgBtn = btn
        }
        if btmView == nil {
            let view = UIView()
            view.backgroundColor = UIColor.white
            btmView = view
            self.view.addSubview(btmView!)
            btmView!.snp.makeConstraints { (make) in
                make.left.bottom.right.equalTo(0)
                make.height.equalTo(240)
            }
            showAreaSelect(view:btmView!)
            
            let rightBtn = UIButton()
            rightBtn.setTitle("确定", for: .normal)
            rightBtn.setTitleColor(UIColor(named: "蓝色字体颜色"), for: .normal)
            rightBtn.titleLabel?.font = UIFont.systemFont(ofSize: 15)
            rightBtn.addTarget(self, action: #selector(adrSelectFinish(sender:)), for: .touchUpInside)
            btmView?.addSubview(rightBtn)
            rightBtn.snp.makeConstraints { (make) in
                make.right.equalTo(-15)
                make.top.equalTo(10)
                make.height.equalTo(30)
                make.width.equalTo(50)
            }
            
            let leftBtn = UIButton()
            leftBtn.setTitle("取消", for: .normal)
            leftBtn.setTitleColor(UIColor(named: "多选按钮字体颜色"), for: .normal)
            leftBtn.titleLabel?.font = UIFont.systemFont(ofSize: 15)
            leftBtn.addTarget(self, action: #selector(closeAction(sender:)), for: .touchUpInside)
            btmView?.addSubview(leftBtn)
            leftBtn.snp.makeConstraints { (make) in
                make.left.equalTo(15)
                make.top.equalTo(10)
                make.height.equalTo(30)
                make.width.equalTo(50)
            }
        }
        
    }
    
    
    var isChange = false
    
    @objc func adrSelectFinish(sender:UIButton){
        
        var proName = ""
        var cityName = ""
        var areaName = ""
        cityDict["area_id"] = ""
        areaDict["area_id"] = ""
        cityDict["area_name"] = ""
        areaDict["area_name"] = ""
        
        proName = proDict["area_name"] as! String
        if (proDict["city_list"] as! NSArray).count > 0 {
            cityDict = (proDict["city_list"] as! NSArray)[cityIndex] as! [String: AnyObject]
            cityName = cityDict["area_name"] as! String
            if (cityDict["district_list"] as! NSArray).count > 0 {
                areaDict = (cityDict["district_list"] as! NSArray)[areaIndex] as! Dictionary<String,Any>
                areaName = areaDict["area_name"] as! String
            }
        }
        
        if provinceIndex != tempProvince_select || cityIndex != tempCity_select || areaIndex != tempArea_select {
            isChange = true
        }else{
            isChange = false
        }
        
        
        
        var selectAdr = proName
        if cityName.count > 0 {
            selectAdr = proName + "-" + cityName
            if areaName.count > 0 {
                selectAdr = proName + "-" + cityName + "-" + areaName
            }
        }
        
        
        dzStr = selectAdr
        
        bgBtn?.removeFromSuperview()
        btmView?.subviews.forEach({ (view) in
            view.removeFromSuperview()
        })
        btmView?.removeFromSuperview()
        btmView = nil
        bgBtn = nil
        list_view.reloadData()
    }
    
    
    func getIndex(){
        
        let path = Bundle.main.path(forResource: "address_new", ofType: "json")
        let url = URL(fileURLWithPath: path!)
        // 带throws的方法需要抛异常
        do {
            let data = try Data(contentsOf: url)
            let jsonData = JSON(data)
            print("地址文件数据",jsonData["data"])
            
            self.addressArray = jsonData["data"].arrayObject!
            //            if navTitle == "编辑地址" {
            for i in 0 ..< addressArray.count {
                let item = addressArray[i] as! Dictionary<String,Any>
                if item["area_id"] as! Int == provinceIndex {
                    let citys = item["city_list"] as! Array<Dictionary<String,Any>>
                    if citys.count == 0 {
                        provinceIndex = i
                    }
                    for j in 0 ..< citys.count {
                        let cItem = citys[j]
                        if cItem["area_id"] as! Int == cityIndex {
                            let districts = cItem["district_list"] as! Array<Dictionary<String,Any>>
                            if districts.count == 0 {
                                cityIndex = j
                            }
                            for k in 0 ..< districts.count{
                                let dItem = districts[k]
                                if dItem["area_id"] as! Int == areaIndex{
                                    provinceIndex = i
                                    cityIndex = j
                                    areaIndex = k
                                    break
                                }
                            }
                        }
                    }
                }else{
                    provinceIndex = 0
                    cityIndex = 0
                    areaIndex = 0
                }
                proDict = addressArray[provinceIndex] as! Dictionary<String,Any>
                //                }
                
            }
        } catch let error as Error? {
            print("读取本地数据出现错误!",error as Any)
        }
    }
    //MARK: - 地址选择
    var proDict:Dictionary<String,Any>  = Dictionary()
    var cityDict:Dictionary<String,Any> = Dictionary()
    var areaDict:Dictionary<String,Any> = Dictionary()
    //选择的省索引
    var provinceIndex = 0
    //选择的市索引
    var cityIndex = 0
    //选择的区（县）索引
    var areaIndex = 0
    
    //选择器
    var pickerView:UIPickerView!
    //所以地址数据集合
    var addressArray:Array<Any> = []
    var dzStr = ""
    //设置选择框的列数为3列,继承于UIPickerViewDataSource协议
    func numberOfComponents(in pickerView: UIPickerView) -> Int {
        
        return 3
    }
    
    //设置选择框的行数，继承于UIPickerViewDataSource协议
    func pickerView(_ pickerView: UIPickerView,
                    numberOfRowsInComponent component: Int) -> Int {
        
        
        if component == 0 {
            return self.addressArray.count
        } else if component == 1 {
            let province = self.addressArray[provinceIndex] as! Dictionary<String,Any>
            return (province["city_list"]! as! NSArray).count
        } else {
            let province = self.addressArray[provinceIndex] as! Dictionary<String,Any>
            if  (province["city_list"] as! NSArray).count == 0 {
                return 0
            }
            if let city = (province["city_list"] as! NSArray)[cityIndex]
                as? [String: AnyObject] {
                print(city["district_list"] as Any)
                return (city["district_list"] as! NSArray).count
            } else {
                return 0
            }
        }
    }
    //设置选择框各选项的内容，继承于UIPickerViewDelegate协议
    func pickerView(_ pickerView: UIPickerView, titleForRow row: Int,
                    forComponent component: Int) -> String? {
        
        if component == 0 {
            let rowDic = self.addressArray[row] as! Dictionary<String,Any>
            return rowDic["area_name"] as? String
        }else if component == 1 {
            let province = self.addressArray[provinceIndex] as! Dictionary<String,Any>
            let city = (province["city_list"] as! NSArray)[row]
                as! [String: AnyObject]
            return city["area_name"] as? String
        }else {
            let province = self.addressArray[provinceIndex] as! Dictionary<String,Any>
            let city = (province["city_list"] as! NSArray)[cityIndex]
                as! [String: AnyObject]
            let area = (city["district_list"] as! NSArray)[row] as! Dictionary<String,Any>
            return area["area_name"] as? String
        }
    }
    
    //选中项改变事件（将在滑动停止后触发）
    func pickerView(_ pickerView: UIPickerView, didSelectRow row: Int,
                    inComponent component: Int) {
        //根据列、行索引判断需要改变数据的区域
        switch (component) {
        case 0:
            provinceIndex = row;
            pickerView.reloadComponent(1);
            pickerView.reloadComponent(2);
            pickerView.selectRow(cityIndex, inComponent: 1, animated: false)
            pickerView.selectRow(areaIndex, inComponent: 2, animated: false)
        case 1:
            cityIndex = row;
            pickerView.reloadComponent(2);
            pickerView.selectRow(areaIndex, inComponent: 2, animated: false)
        case 2:
            areaIndex = row;
        default:
            break;
        }
    }
    func pickerView(_ pickerView: UIPickerView, rowHeightForComponent component: Int) -> CGFloat {
        
        return 50
    }
    //自定义UIPickerView
    func pickerView(_ pickerView: UIPickerView, viewForRow row: Int, forComponent component: Int, reusing view: UIView?) -> UIView {
        
        
        let genderLbl = UILabel()
        genderLbl.textAlignment = .center
        genderLbl.font = UIFont.systemFont(ofSize: 15)
        genderLbl.textColor = UIColor.init(named: "标题字颜色")
        
        if component == 0 {
            let rowDic = self.addressArray[row] as! Dictionary<String,Any>
            genderLbl.text = rowDic["area_name"] as? String
        }else if component == 1 {
            let province = self.addressArray[provinceIndex] as! Dictionary<String,Any>
            let city = (province["city_list"] as! NSArray)[row]
                as! [String: AnyObject]
            genderLbl.text = city["area_name"] as? String
        }else {
            let province = self.addressArray[provinceIndex] as! Dictionary<String,Any>
            let city = (province["city_list"] as! NSArray)[cityIndex]
                as! [String: AnyObject]
            let area = (city["district_list"] as! NSArray)[row] as! Dictionary<String,Any>
            genderLbl.text = area["area_name"] as? String
        }
        
        return genderLbl
    }
    
    var tempProvince_select = -1//临时省id
    var tempCity_select = -1//临时市id
    var tempArea_select = -1//临时区id
    //MARK: - 上传图片
    func DZSH_Upload_Cer_Cell_UpLoadImg(cell: DZSH_Upload_Cer_Cell) {
        print(cell.tag)
        selectUpLoadImg(tag: cell.tag)
    }
    //MARK: - 填写内容
    func textFieldContent(content: String, cell: TitleAndTFCell) {
        switch cell.tag {
        case 10:
            shop_name = content
            break
        case 14:
            adr_str = content
            break
        case 31:
            pickup_phone = content
            break
        case 32:
            pickup_address = content
            break
        case 40:
            shop_tel = content
            break
        case 41:
            shop_scale = content
            break
        case 43:
            contacts_name = content
            break
        case 44:
            shop_email = content
            break
        case 50:
            business_licence_number = content
            break
        case 51:
            business_sphere = content
            break
        default:
            break
        }
    }
}
