//
//  DZSH_UPLOAD_IMG_CELL.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2021/3/15.
//  Copyright © 2021 junye lu. All rights reserved.
//

import UIKit
protocol DZSH_UPLOAD_IMG_CELL_Delegate {
    func DZSH_UPLOAD_IMG_CELL_Btn_Action(select:Int,cell:DZSH_UPLOAD_IMG_CELL)
    func DZSH_UPLOAD_IMG_CELL_Input(str:String,cell:DZSH_UPLOAD_IMG_CELL)
    func DZSH_UPLOAD_IMG_CELL_SelectImg(cell:DZSH_UPLOAD_IMG_CELL)
}
class DZSH_UPLOAD_IMG_CELL: UITableViewCell {
    @IBAction func btn_click(_ sender: UIButton) {
        delegate?.DZSH_UPLOAD_IMG_CELL_Btn_Action(select: sender.tag, cell: self)
    }
    var delegate:DZSH_UPLOAD_IMG_CELL_Delegate?
    @IBOutlet weak var titleLbl: UILabel!

    @IBOutlet weak var input_tf: UITextField!
    @IBOutlet weak var rightBtn: UIButton!
    @IBOutlet weak var leftBtn: UIButton!
    @IBOutlet weak var img_view: UIImageView!
    @IBOutlet weak var nameLbl: UILabel!
    @IBOutlet weak var bottom_lbl: UILabel!

    override func awakeFromNib() {
        super.awakeFromNib()
        self.selectionStyle = .none
        input_tf.addTarget(self, action: #selector(textChange(tf:)), for: .allEditingEvents)
        let tap = UITapGestureRecognizer(target: self, action: #selector(tapAction))
        img_view.addGestureRecognizer(tap)
        // Initialization code
    }
    @objc func tapAction(){
        delegate?.DZSH_UPLOAD_IMG_CELL_SelectImg(cell: self)
    }
    @objc func textChange(tf:UITextField){
        delegate?.DZSH_UPLOAD_IMG_CELL_Input(str: tf.text!, cell: self)
    }

    override func setSelected(_ selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)

        // Configure the view for the selected state
    }
    
}
