//
//  Location_Cell.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2021/3/17.
//  Copyright © 2021 junye lu. All rights reserved.
//

import UIKit
protocol Location_Cell_Delegate {
    func Location_Cell_action()
    func Location_Cell_input_tf(idx:Int,str:String)
}
class Location_Cell: UITableViewCell {
    var delegate:Location_Cell_Delegate?
    @IBAction func get_loc_action(_ sender: Any) {
        delegate?.Location_Cell_action()
    }
    @IBOutlet weak var lng_tf: UITextField!
    @IBOutlet weak var lat_tf: UITextField!
    override func awakeFromNib() {
        super.awakeFromNib()
        // Initialization code
        self.selectionStyle = .none
        lng_tf.addTarget(self, action: #selector(textChange(tf:)), for: .allEditingEvents)
        lng_tf.tag = 1
        
        lat_tf.addTarget(self, action: #selector(textChange(tf:)), for: .allEditingEvents)
        lat_tf.tag = 0
    }

    @objc func textChange(tf:UITextField){
        delegate?.Location_Cell_input_tf(idx: tf.tag, str: tf.text!)
    }
    
    override func setSelected(_ selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)

        // Configure the view for the selected state
    }
    
}
