//
//  PrintListMgVc.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2021/1/18.
//  Copyright © 2021 junye lu. All rights reserved.
//

import UIKit
import Parchment
import LGButton
import WebKit

class PrintListMgVc: BaseViewController, PagingViewControllerDelegate,UIPrintInteractionControllerDelegate,WKNavigationDelegate {
    let web_vc = WebViewController()
    @IBAction func check_detail(_ sender: UIButton) {
        web_vc.titleStr = "打印预览"
        let dic = ["user_token":UserToken as Any,
                   "order_id":order_id as Any,
                   "remittance_account":"" as Any,
                   "province_id":"" as Any,
                   "city_id":"" as Any,
                   "district_id":"" as Any,
                   "mobile":"" as Any,
                   "consignee":"" as Any
        ]
        printUrl(dic) { (data) in
            let d = data as! printUrl_Model
            let web_vc = WebViewController()
            web_vc.urlStr = d.data
            self.navigationController?.pushViewController(web_vc, animated: true)
        } failture: { (err) in
            
        }
        
        
    }
    
    @IBAction func print_action(_ sender: LGButton) {
        
        
        if userName != "不二制油" { //普通
            let dic = ["user_token":UserToken as Any,
                       "order_id":order_id as Any,
                       "remittance_account":"" as Any,
                       "province_id":"" as Any,
                       "city_id":"" as Any,
                       "district_id":"" as Any,
                       "mobile":"" as Any,
                       "consignee":"" as Any,
                       "print_type":1 as Any
            ]
            printUrl(dic) { (data) in
                let d = data as! printUrl_Model
                let urlStr = d.data?.addingPercentEncoding(withAllowedCharacters: .urlQueryAllowed)!
                let url = URL(string: urlStr!)
                let request = URLRequest.init(url: url!, cachePolicy: .reloadRevalidatingCacheData, timeoutInterval: 10)
                self.web_vc.wkWebView.load(request)
                HUD.flash(.progress)
            } failture: { (err) in
                
            }
            
        }else{
            let vc = viewControllers[selectIndex]
            if selectIndex != 0 {
                
                if vc.FM_str.count == 0 {
                    HUD.flash(.label("请输入汇款账户"), delay: 1.2)
                    return
                }
                if vc.dzStr.count == 0 && vc.type != 1 {
                    HUD.flash(.label("请选择区域"), delay: 1.2)
                    return
                }
                if vc.detail_adr_str.count == 0 {
                    HUD.flash(.label("请填写地址"), delay: 1.2)
                    return
                }
                if vc.phone_str.count == 0 {
                    HUD.flash(.label("请填写电话"), delay: 1.2)
                    return
                }
                if vc.consignee_str.count == 0 {
                    HUD.flash(.label("请填写联系人"), delay: 1.2)
                    return
                }
            }
            var dic:Dictionary<String,Any> = Dictionary()
            if vc.isChange {
                dic = ["user_token":UserToken as Any,
                       "order_id":order_id as Any,
                       "remittance_account":vc.FM_str as Any,
                       "province_id":vc.proDict["area_id"] as Any,
                       "city_id":vc.cityDict["area_id"] as Any,
                       "district_id":vc.areaDict["area_id"] as Any,
                       "mobile":vc.phone_str as Any,
                       "consignee":vc.consignee_str as Any,
                       "address_str":vc.detail_adr_str as Any,
                       "odd_numbers":vc.order_num_str as Any,
                       "add_time_year":vc.year as Any,
                       "add_time_month":vc.month as Any,
                       "add_time_day":vc.day as Any,
                       "print_type":vc.type as Any
                ]
                let dict = ["user_token":UserToken as Any,
                           "order_id":order_id as Any,
                           "remittance_account":vc.FM_str as Any,
                           "province_id":vc.proDict["area_id"] as Any,
                           "city_id":vc.cityDict["area_id"] as Any,
                           "district_id":vc.areaDict["area_id"] as Any,
                           "mobile":vc.phone_str as Any,
                           "consignee":vc.consignee_str as Any,
                           "address_str":vc.detail_adr_str as Any,
                           "print_type":vc.type as Any
                    ]
                changePrintInfo(dict) { (data) in
                    printUrl(dic) { (data) in
                        let d = data as! printUrl_Model
                        let urlStr = d.data?.addingPercentEncoding(withAllowedCharacters: .urlQueryAllowed)!
                        let url = URL(string: urlStr!)
                        let request = URLRequest.init(url: url!, cachePolicy: .reloadRevalidatingCacheData, timeoutInterval: 10)
                        self.web_vc.wkWebView.load(request)
                        HUD.flash(.progress, delay: 1.2)
                    } failture: { (err) in
                        
                    }
                } failture: { (err) in
                    
                }
                return
            }else{
                dic = ["user_token":UserToken as Any,
                       "order_id":order_id as Any,
                       "remittance_account":vc.FM_str as Any,
                       "province_id":"" as Any,
                       "city_id":"" as Any,
                       "district_id":"" as Any,
                       "mobile":vc.phone_str as Any,
                       "consignee":vc.consignee_str as Any,
                       "address_str":vc.detail_adr_str as Any,
                       "odd_numbers":vc.order_num_str as Any,
                       "add_time_year":vc.year as Any,
                       "add_time_month":vc.month as Any,
                       "add_time_day":vc.day as Any,
                       "print_type":vc.type as Any
                ]
            }
            printUrl(dic) { (data) in
                let d = data as! printUrl_Model
                let urlStr = d.data?.addingPercentEncoding(withAllowedCharacters: .urlQueryAllowed)!
                let url = URL(string: urlStr!)
                let request = URLRequest.init(url: url!, cachePolicy: .reloadRevalidatingCacheData, timeoutInterval: 10)
                self.web_vc.wkWebView.load(request)
                HUD.flash(.progress, delay: 1.2)
            } failture: { (err) in
                
            }
        }
    }
    
    func webView(_ webView: WKWebView, didFinish navigation: WKNavigation!){
        print("页面加载完成...")
        
            delay(0.5) { [self] in
                let pc = UIPrintInteractionController.shared
                // 打印任务相关信息
                let printInfo = UIPrintInfo(dictionary:nil)
                printInfo.outputType = UIPrintInfo.OutputType.general
                printInfo.jobName = "my print Job"
                pc.printInfo = printInfo
                pc.delegate = self
                let formatter = webView.viewPrintFormatter()
                pc.printFormatter = formatter
                formatter.startPage = 0
                pc.present(animated: true) { (printer, result, err) in
                    print(result)
                }
            }
        
    }
    
    @IBOutlet weak var contentV: UIView!
    var printData:printOrder_data_res_model?{
        didSet{
          
            viewControllers.forEach { (vc) in
                if printData?.province_id != nil {
                    vc.provinceIndex = (printData?.province_id)!
                    vc.cityIndex = (printData?.city_id)!
                    vc.areaIndex = (printData?.district_id)!
                }
                if printData?.remittance_account != nil {
                    vc.FM_str = (printData?.remittance_account)!
                }
                if printData?.mobile != nil {
                    vc.phone_str = (printData?.mobile)!
                }
                if printData?.consignee != nil {
                    vc.consignee_str = (printData?.consignee)!
                }
                if printData?.address_str != nil {
                    vc.detail_adr_str = (printData?.address_str)!
                }
                if printData?.odd_numbers != nil {
                    vc.order_num_str = (printData?.odd_numbers)!
                }
                if printData?.add_time_year != nil {
                    vc.year = (printData?.add_time_year)!
                    vc.month = (printData?.add_time_month)!
                    vc.day = (printData?.add_time_day)!
                }
                
            }
        }
    }
    
    fileprivate let cities = [
        "普通订单打印",
        "订货单打印模版1",
        "订货单打印模版2"
    ]
    
    
    let viewControllers = [
        PrintViewController(title: "普通订单打印"),
        PrintViewController(title: "订货单打印模版1"),
        PrintViewController(title: "订货单打印模版2")
    ]
    var selectIndex = 0
    //头部滚动视图
    weak var pagingVC : PagingViewController?
    
    @IBOutlet weak var holder_img: UIImageView!
    let UserToken = UserDefaults.standard.value(forKey: "user_token")
    let userName = UserDefaults.standard.string(forKey: "userName")
    var order_id = 0 {
        didSet {
            viewControllers.forEach { (vc) in
                vc.order_id = order_id
            }
        }
    }
    @IBOutlet weak var normal_type_btn: UIButton!
    override func viewDidLoad() {
        super.viewDidLoad()
        web_vc.wkWebView.navigationDelegate = self
        let vc = viewControllers[0]
        vc.isNormal = true
        let vc2 = viewControllers[1]
        vc2.type = 2
        let vc3 = viewControllers[2]
        vc3.type = 3
        
        navbar.title = "打印模版确认"
        navbar.lineView.isHidden = true
        self.view.addSubview(navbar)
        SetTopFrameView(view: contentV, btmView: self.view)
        
        if userName != "不二制油" {
            normal_type_btn.isHidden = false
        }else{
            normal_type_btn.isHidden = true
            let pagingViewController = PagingViewController(viewControllers: viewControllers)
            pagingViewController.indicatorColor = UIColor.init(named: "蓝色字体颜色")!
            pagingViewController.menuItemSize = .fixed(width: 0, height: 44*glscale)
            pagingViewController.font = UIFont.systemFont(ofSize: 13)
            pagingViewController.selectedFont = UIFont.systemFont(ofSize: 13)
            pagingViewController.textColor = UIColor.init(named: "灰色字体颜色")!
            pagingViewController.selectedTextColor = UIColor.init(named: "蓝色字体颜色")!
            pagingViewController.delegate = self
            pagingViewController.dataSource = self
            pagingViewController.sizeDelegate = self
            addChild(pagingViewController)
            contentV.addSubview(pagingViewController.view)
            contentV.backgroundColor = UIColor(named: "app底色")!
            contentV.constrainToEdges(pagingViewController.view)
            pagingViewController.didMove(toParent: self)
            pagingVC = pagingViewController
        }
        holder_img.isHidden = normal_type_btn.isHidden
        
        pagingVC?.select(index: selectIndex)
        
        // Do any additional setup after loading the view.
    }
    
    @IBOutlet weak var btm_lbl: UILabel!
    func pagingViewController(
        _ pagingViewController: PagingViewController,
        didScrollToItem pagingItem: PagingItem,
        startingViewController: UIViewController?,
        destinationViewController: UIViewController,
        transitionSuccessful: Bool){
        if transitionSuccessful {
            guard let item = pagingItem as? PagingIndexItem else { return}
            if selectIndex != item.index {
                selectIndex = item.index
            }
        }
    }
    
    
}

extension PrintListMgVc: PagingViewControllerDataSource {
    
    func pagingViewController(_: PagingViewController, pagingItemAt index: Int) -> PagingItem {
        return PagingIndexItem(index: index, title: cities[index])
    }
    
    func pagingViewController(_: PagingViewController, viewControllerAt index: Int) -> UIViewController {
        return viewControllers[index]
    }
    
    func numberOfViewControllers(in pagingViewController: PagingViewController) -> Int {
        return cities.count
    }
    
}

extension PrintListMgVc: PagingViewControllerSizeDelegate {
    
    
    func pagingViewController(_ pagingViewController: PagingViewController, widthForPagingItem pagingItem: PagingItem, isSelected: Bool) -> CGFloat {
        
        return ScreenWidth/2.5
    }
    
}
