//
//  print_bottom_cell.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2021/1/18.
//  Copyright © 2021 junye lu. All rights reserved.
//

import UIKit
protocol print_bottom_cellDelegate {
    func print_bottom_cell_select_place_action()
    func print_bottom_cell_text_respose(tag:Int,text:String)
    func print_bottom_cell_time_select()
}
class print_bottom_cell: UITableViewCell {

    var delegate:print_bottom_cellDelegate?
    @IBOutlet weak var adr_lbl: UILabel!
    @IBOutlet weak var consignee_tf: UITextField!
    @IBOutlet weak var phone_tf: UITextField!
    @IBOutlet weak var payer_tf: UITextField!
    @IBOutlet weak var adr_tf: UITextField!
    @IBAction func adr_select(_ sender: UIButton) {
        delegate?.print_bottom_cell_select_place_action()
    }
    @IBAction func time_select_action(_ sender: UIButton) {
        delegate?.print_bottom_cell_time_select()
    }
    @IBOutlet weak var day_lbl: UILabel!
    @IBOutlet weak var month_lbl: UILabel!
    @IBOutlet weak var year_lbl: UILabel!
    @IBOutlet weak var order_number_tf: UITextField!
    @IBOutlet weak var middle_bg: UIView!
    @IBOutlet weak var top_bg: UIView!
    @IBOutlet weak var btm_bg: UIView!
    override func awakeFromNib() {
        super.awakeFromNib()
        self.selectionStyle = .none
        top_bg.layer.masksToBounds = false
        middle_bg.layer.masksToBounds = false
        btm_bg.layer.masksToBounds = false
        // Initialization code
        payer_tf.tag = 0
        adr_tf.tag = 1
        phone_tf.tag = 2
        consignee_tf.tag = 3
        order_number_tf.tag = 4
        
        order_number_tf.addTarget(self, action: #selector(textChange(tf:)), for: .allEditingEvents)
        payer_tf.addTarget(self, action: #selector(textChange(tf:)), for: .allEditingEvents)
        adr_tf.addTarget(self, action: #selector(textChange(tf:)), for: .allEditingEvents)
        phone_tf.addTarget(self, action: #selector(textChange(tf:)), for: .allEditingEvents)
        consignee_tf.addTarget(self, action: #selector(textChange(tf:)), for: .allEditingEvents)
    }
    
    @objc func textChange(tf:UITextField){
        delegate?.print_bottom_cell_text_respose(tag: tf.tag, text: tf.text!)
    }

    override func setSelected(_ selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)

        // Configure the view for the selected state
    }
    
}
