//
//  NewPiCiCell.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2021/3/9.
//  Copyright © 2021 junye lu. All rights reserved.
//

import UIKit
protocol NewPiCiCellDelegate {
    func NewPiCiCellScrollAction(x:CGFloat)
    func NewPiCiXuanZeCellBtnTextChange(sender:String,cell:NewPiCiCell)
    func NewPiCiXuanZeCellBtnSelect(cell:NewPiCiCell)
    func NewPiCiXuanZeCellRefreshCount(cell:NewPiCiCell)
    
}
class NewPiCiCell: UITableViewCell, UIScrollViewDelegate,UITextFieldDelegate{

    @IBAction func select_action(_ sender: UIButton) {
        select_btn.isSelected = !select_btn.isSelected
        if select_btn.isSelected {
            textTf.textColor = UIColor(named: "蓝色字体颜色")
            textTf.layer.borderColor = UIColor(named: "蓝色字体颜色")?.cgColor
        }else{
            textTf.textColor = UIColor(named: "9A9A9A")
            textTf.layer.borderColor = UIColor(named: "9A9A9A")?.cgColor
        }
        delegate?.NewPiCiXuanZeCellBtnSelect(cell: self)
    }
    @IBOutlet weak var select_btn: UIButton!
    @IBOutlet weak var bg_view: UIView!
    
    
    var dateLbl = UILabel()
    var nameLbl = UILabel()
    var SLLbl = UILabel()
    var textTf = UITextField()
    var statusLbl = UILabel()
    var scroll_view = UIScrollView()
    var delegate:NewPiCiCellDelegate?
    override func awakeFromNib() {
        super.awakeFromNib()
        self.selectionStyle = .none
        scroll_view.bounces = false
        bg_view.addSubview(scroll_view)
        scroll_view.snp.makeConstraints { (make) in
            make.top.left.right.bottom.equalToSuperview()
        }
        scroll_view.contentSize = CGSize(width: 448, height: 49)
        scroll_view.showsHorizontalScrollIndicator = false
        scroll_view.showsVerticalScrollIndicator = false
        scroll_view.addSubview(nameLbl)
        scroll_view.addSubview(dateLbl)
        scroll_view.addSubview(SLLbl)
        scroll_view.addSubview(textTf)
        scroll_view.addSubview(statusLbl)
        scroll_view.delegate = self
        
        setTextFrame(lbl: nameLbl)
        nameLbl.frame = CGRect(x: 0, y: 0, width: 95, height: 49)
        setTextFrame(lbl: SLLbl)
        SLLbl.frame = CGRect(x: 95, y: 0, width: 92, height: 49)
        textTf.frame = CGRect(x: SLLbl.frame.maxX + 15, y: 9.5, width: 70, height: 32)
        textTf.layer.borderWidth = 1
        textTf.textAlignment = .center
        textTf.layer.cornerRadius = 3
        textTf.layer.masksToBounds = true
        textTf.textColor = UIColor(named: "9A9A9A")
        textTf.layer.borderColor = UIColor(named: "9A9A9A")?.cgColor
        
        setTextFrame(lbl: statusLbl)
        statusLbl.frame = CGRect(x: textTf.frame.maxX + 15, y: 0, width: 66, height: 49)
        setTextFrame(lbl: dateLbl)
        dateLbl.frame = CGRect(x: statusLbl.frame.maxX , y: 0, width: 95, height: 49)
        // Initialization code
        textTf.keyboardType = .numberPad
        textTf.delegate = self
        textTf.addTarget(self, action: #selector(textChange(sender:)), for: .editingChanged)
    }

    func setTextFrame(lbl:UILabel){
        lbl.textColor = UIColor(named: "标题字颜色")
        lbl.font = UIFont.systemFont(ofSize: 13)
        lbl.textAlignment = .center
        lbl.text = "123"
    }
    
    func scrollViewDidScroll(_ scrollView: UIScrollView) {
        delegate?.NewPiCiCellScrollAction(x: scrollView.contentOffset.x)
    }
    
    func textFieldDidEndEditing(_ textField: UITextField) {
        
        if isPurnInt(string: textTf.text!){
           delegate?.NewPiCiXuanZeCellRefreshCount(cell:self)
        }
    }
    @objc func textChange(sender:UITextField){
        if isPurnInt(string: textTf.text!){
            let num1 = textTf.text as! NSString
            let num2 = SLLbl.text as! NSString
            if num1.integerValue > num2.integerValue {
                HUD.flash(.label("超出库存"), delay: 1.2)
                textTf.text = SLLbl.text
            }
            if num1.integerValue == 0{
                HUD.flash(.label("出库数量不能为0"), delay: 1.2)
                textTf.text = ""
            }
            delegate?.NewPiCiXuanZeCellBtnTextChange(sender: textTf.text!, cell: self)
        }
    }
    
    
    override func setSelected(_ selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)

        // Configure the view for the selected state
    }
    
}
