//
//  CZ_Vc.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2021/4/2.
//  Copyright © 2021 junye lu. All rights reserved.
//

import UIKit

class CZ_Vc: BaseViewController {

    @IBOutlet weak var top_view: UIView!
    @IBOutlet weak var bank_number: UILabel!
    @IBOutlet weak var bank_account_number: UILabel!
    @IBOutlet weak var bank_adr: UILabel!
    @IBOutlet weak var bank_name: UILabel!
    @IBOutlet weak var user_account: UILabel!
    var userToken = ""
    @IBAction func copy_action(_ sender: UIButton) {
        let pastboard = UIPasteboard.general
        pastboard.string = bank_account_number.text
        HUD.flash(.success, delay: 0.5)
    }
    
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = "充值"
        self.view.addSubview(navbar)

        top_view.snp.makeConstraints { (make) in
            make.top.equalTo(NavHeight + 12)
            make.left.equalTo(15)
            make.right.equalTo(-15)
            make.height.equalTo(238.5)
        }
        
        rechargeOperation(["user_token":userToken as Any]) {[self] (data) in
            let model = data as! rechargeOperation_model
            user_account.text = model.data?.clt_nm
            bank_name.text = model.data?.bank_name
            bank_adr.text = model.data?.bank_branch
            bank_number.text = model.data?.bank_branch_num
            bank_account_number.text = model.data?.bnk_eid
        } failture: { (err) in
            
        }

    }
}
