//
//  GPrinter_Cell.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2021/1/27.
//  Copyright © 2021 junye lu. All rights reserved.
//

import UIKit
protocol GPrinter_Cell_Delegate {
    func GPrinter_Cell_select_item(selects:Array<Int>,cell:GPrinter_Cell)
    func GPrinter_Cell_print_copy(num:Array<Int>,cell:GPrinter_Cell)
}
class GPrinter_Cell: UITableViewCell {
    var delegate:GPrinter_Cell_Delegate?
    @IBOutlet weak var title_lbl_3: UILabel!
    @IBOutlet weak var title_lbl_2: UILabel!
    @IBOutlet weak var title_lbl_1: UILabel!
    @IBAction func select_all(_ sender: UIButton) {
        all_select_btn.isSelected = !all_select_btn.isSelected
        if all_select_btn.isSelected {
            select_arr.removeAll()
            for i in 0 ..< piciArr.count {
                select_arr.append(i)
            }
        }else{
            select_arr.removeAll()
            for _ in 0 ..< piciArr.count {
                select_arr.append(999999)
            }
        }
        delegate?.GPrinter_Cell_select_item(selects: select_arr, cell: self)
        delegate?.GPrinter_Cell_print_copy(num: print_copy_arr, cell: self)
    }
    @IBOutlet weak var bg_view: UIView!
    @IBOutlet weak var all_select_btn: UIButton!
    @IBOutlet weak var name_lbl: UILabel!
    override func awakeFromNib() {
        super.awakeFromNib()
        // Initialization code
        self.selectionStyle = .none
        
    }
    
    func setUI(){
        if bg_view.subviews.count > 0 {
            bg_view.subviews.forEach { (item) in
                item.removeFromSuperview()
            }
        }
        if piciArr.count == 0 {return}
        for i in 0 ..< piciArr.count {
            
            if select_arr.count != piciArr.count {
                select_arr.append(999999)
                print_copy_arr.append(1)
            }
            let view = UIView()
            view.tag = i
            bg_view.addSubview(view)
            view.snp.makeConstraints { (make) in
                make.left.right.equalTo(0)
                make.height.equalTo(67)
                make.top.equalTo(i * 67)
            }
            let btn = UIButton(frame: CGRect(x: 0, y: 0, width: 44, height: 67))
            btn.tag = i
            view.addSubview(btn)
            btn.setImage(UIImage(named: "daixuan"), for: .normal)
            btn.setImage(UIImage(named: "yuxuan"), for: .selected)
            btn.addTarget(self, action: #selector(single_select(btn:)), for: .touchUpInside)
            if btn.tag == select_arr[i] {
                btn.isSelected = true
            }else{
                btn.isSelected = false
            }
            let num_lbl = UILabel()
            num_lbl.textColor = UIColor(named: "个人中心灰色字体")
            num_lbl.font = UIFont.systemFont(ofSize: 13)
            view.addSubview(num_lbl)
            num_lbl.text = "330"
            num_lbl.snp.makeConstraints { (make) in
                make.centerY.equalTo(btn.snp_centerY)
                make.centerX.equalTo(title_lbl_1.snp_centerX)
            }
            
            let type_lbl = UILabel()
            type_lbl.textColor = UIColor(named: "个人中心灰色字体")
            type_lbl.font = UIFont.systemFont(ofSize: 13)
            view.addSubview(type_lbl)
            type_lbl.text = "正常"
            type_lbl.snp.makeConstraints { (make) in
                make.centerY.equalTo(btn.snp_centerY)
                make.centerX.equalTo(title_lbl_2.snp_centerX)
            }
            
            let textTf = UITextField()
            textTf.tag = i + 90000
            textTf.addTarget(self, action: #selector(textChange(textF:)), for: .allEditingEvents)
            view.addSubview(textTf)
            textTf.borderStyle = .none
            textTf.keyboardType = .numberPad
            textTf.layer.borderWidth = 0.5
            textTf.layer.borderColor = UIColor(named: "灰色分界线")?.cgColor
            textTf.backgroundColor = UIColor(named: "#EDF2F7")
            textTf.textColor = UIColor(named: "标题字颜色")
            textTf.text = "1"
            textTf.font = UIFont.systemFont(ofSize: 13)
            textTf.textAlignment = .center
            textTf.layer.cornerRadius = 3
            textTf.layer.masksToBounds = true
            textTf.snp.makeConstraints { (make) in
                make.centerX.equalTo(title_lbl_3.snp_centerX)
                make.centerY.equalTo(btn.snp_centerY)
                make.width.equalTo(65)
                make.height.equalTo(37)
            }
            
            let leftImg = UIImageView()
            leftImg.tag = 1000 + i
            leftImg.image = UIImage(named: "gray_del")
            view.addSubview(leftImg)
            leftImg.snp.makeConstraints { (make) in
                make.centerY.equalTo(btn.snp_centerY)
                make.right.equalTo(textTf.snp_left).offset(-8)
                make.width.height.equalTo(20)
            }
            
            let leftBtn = UIButton()
            leftBtn.isUserInteractionEnabled = false
            leftBtn.tag = 20000 + i
            leftBtn.addTarget(self, action: #selector(edit_count(btn:)), for: .touchUpInside)
            view.addSubview(leftBtn)
            leftBtn.snp.makeConstraints { (make) in
                make.center.equalTo(leftImg.snp_center)
                make.width.height.equalTo(28)
            }
            
            let rightImg = UIImageView()
            rightImg.tag = 3000 + i
            rightImg.image = UIImage(named: "blue_add")
            view.addSubview(rightImg)
            rightImg.snp.makeConstraints { (make) in
                make.centerY.equalTo(btn.snp_centerY)
                make.left.equalTo(textTf.snp_right).offset(8)
                make.width.height.equalTo(20)
            }
            
            let rightBtn = UIButton()
            rightBtn.tag = 40000 + i
            rightBtn.addTarget(self, action: #selector(edit_count(btn:)), for: .touchUpInside)
            view.addSubview(rightBtn)
            rightBtn.snp.makeConstraints { (make) in
                make.center.equalTo(rightImg.snp_center)
                make.width.height.equalTo(28)
            }
        }
    }
    var select_arr:Array<Int> = []
    var print_copy_arr:Array<Int> = []
    @objc func edit_count(btn:UIButton){
        if btn.tag  >=  20000 && btn.tag < 40000{
            let tf = viewWithTag(90000 + btn.tag - 20000) as! UITextField
            var num = Int(tf.text!)
            num! -= 1
            if num == 1 {
                let leftBtn = viewWithTag(btn.tag) as! UIButton
                leftBtn.isUserInteractionEnabled = false
                let leftImg = viewWithTag(1000+btn.tag - 20000) as! UIImageView
                leftImg.image = UIImage(named: "gray_del")
            }
            tf.text = StringByInt(number: num!)
            print_copy_arr.insert(Int(tf.text!)!, at: tf.tag - 90000)
            print_copy_arr.remove(at: tf.tag - 90000 + 1)
        }
        if btn.tag >= 40000 {
            let tf = viewWithTag(90000 + btn.tag - 40000) as! UITextField
            var num = Int(tf.text!)
            num! += 1
            tf.text = StringByInt(number: num!)
            let leftBtn = viewWithTag(20000 + btn.tag - 40000) as! UIButton
            leftBtn.isUserInteractionEnabled = true
            let leftImg = viewWithTag(1000+btn.tag - 40000) as! UIImageView
            leftImg.image = UIImage(named: "blue_del")
            print_copy_arr.insert(Int(tf.text!)!, at: tf.tag - 90000)
            print_copy_arr.remove(at: tf.tag - 90000 + 1)
        }
        delegate?.GPrinter_Cell_print_copy(num: print_copy_arr, cell: self)
        
    }
    @objc func textChange(textF:UITextField){
        if textF.text == "0" {
            textF.text = "1"
        }
        if textF.text?.count != nil {
            print_copy_arr.insert(Int(textF.text!)!, at: textF.tag - 90000)
            print_copy_arr.remove(at: textF.tag - 90000 + 1)
        }
        delegate?.GPrinter_Cell_print_copy(num: print_copy_arr, cell: self)
    }
    override func layoutIfNeeded() {
        super.layoutIfNeeded()
        
        for i in 0 ..< bg_view.subviews.count {
            let view = bg_view.subviews[i]
        
            if print_copy_arr[i] > 1 {
                let tf = viewWithTag(90000 + i) as! UITextField
                tf.text = StringByInt(number: print_copy_arr[i])
                let leftBtn = viewWithTag(20000 + i) as! UIButton
                leftBtn.isUserInteractionEnabled = true
                let leftImg = viewWithTag(1000+i) as! UIImageView
                leftImg.image = UIImage(named: "blue_del")
            }else{
                let tf = viewWithTag(90000 + i) as! UITextField
                let leftBtn = viewWithTag(20000 + i) as! UIButton
                leftBtn.isUserInteractionEnabled = false
                let leftImg = viewWithTag(1000 + i) as! UIImageView
                leftImg.image = UIImage(named: "gray_del")
                tf.text = StringByInt(number: print_copy_arr[i])
            }
            
            if view.tag == select_arr[i] {
                view.subviews.forEach { (item) in
                    if item.isMember(of: UIButton.classForCoder()){
                        let btn = item as! UIButton
                        btn.isSelected = true
                    }
                }
            }else{
                view.subviews.forEach { (item) in
                    if item.isMember(of: UIButton.classForCoder()){
                        let btn = item as! UIButton
                        btn.isSelected = false
                    }
                }
            }
        }
    }
    
    @objc func single_select(btn:UIButton){
        if btn.isSelected {
            btn.isSelected = false
            select_arr.insert(999999, at: btn.tag)
            select_arr.remove(at: btn.tag+1)
        }else{
            btn.isSelected = true
            select_arr.insert(btn.tag, at: btn.tag)
            select_arr.remove(at: btn.tag+1)
        }
        if select_arr.contains(999999){
            all_select_btn.isSelected = false
        }else{
            all_select_btn.isSelected = true
        }
        delegate?.GPrinter_Cell_select_item(selects: select_arr, cell: self)
        delegate?.GPrinter_Cell_print_copy(num: print_copy_arr, cell: self)
    }
    
    var piciArr:Array<GetGoodBatchDataModel> = []{
        didSet{
            setUI()
        }
    }
    
    
    
    @IBOutlet weak var btm_line: UIView!
    override func setSelected(_ selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)

        // Configure the view for the selected state
    }
    
}
