//
//  S_Y_Detail_Vc.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2021/1/27.
//  Copyright © 2021 junye lu. All rights reserved.
//

import UIKit

class S_Y_Detail_Vc: BaseViewController ,UITableViewDataSource,UITableViewDelegate, scv_cell_delegate{
    func scv_cell_check_img(idx: Int) {
        print("图片 = ",idx)
    }
    
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        if user_type == 0 {
            return 9
        }
        return 11
    }
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        if indexPath.row == 0 {
            return 442
        }
        if indexPath.row < 7 && indexPath.row != 0 {
            return 80.5
        }
        if user_type == 0 {
            if indexPath.row == 8 {
                return 197
            }
        }else{
            if indexPath.row > 8 {
                return 197
            }
        }
        return 114
    }
    var data : OrderDetailGoodsSourceModel?{
        didSet{
            
        }
    }
    var two_titles = ["","","","","","","","供货单位名称"]
    let titles = ["","商品名称","商品规格","产品产地","商品条码","生产日期","保质期","","","",""]
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        
        if indexPath.row == 0 {
            let cell = tableView.dequeueReusableCell(withIdentifier: "img_title_cell") as! img_title_cell
            return cell
        }
        if indexPath.row < 7 && indexPath.row != 0 {
            let cell = tableView.dequeueReusableCell(withIdentifier: "one_title_cell") as! one_title_cell
            cell.title_lbl.text = titles[indexPath.row]
            return cell
        }
        if user_type == 0 {
            if indexPath.row == 8 {
                let cell = tableView.dequeueReusableCell(withIdentifier: "scv_cell") as! scv_cell
                return cell
            }
        }else{
            if indexPath.row > 8 {
                let cell = tableView.dequeueReusableCell(withIdentifier: "scv_cell") as! scv_cell
                cell.title_lbl.text = "供货商资质证书"
                cell.delegate = self
                if indexPath.row == 10 {
                    if user_type == 1 {
                        cell.title_lbl.text = "经销商资质证书"
                    }else{
                        cell.title_lbl.text = "代理商资质证书"
                    }
                }
                return cell
            }
        }
        let cell = tableView.dequeueReusableCell(withIdentifier: "two_title_cell") as! two_title_cell
        cell.title_2_lbl.text = "统一社会信用代码"
        cell.title_1_lbl.text = two_titles[indexPath.row]
        return cell
        
        
    }
    
    var user_type = 0{
        didSet{
            if user_type == 1 {
                two_titles.append("经销商单位名称")
            }
            if user_type == 2 {
                two_titles.append("代理商单位名称")
            }
        }
    }
    @IBOutlet weak var list_view: UITableView!
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = "格利商品安全溯源信息"
        self.view.addSubview(navbar)
        list_view.snp.makeConstraints { (make) in
            make.top.equalTo(navbar.snp_bottom)
            make.left.right.bottom.equalTo(0)
        }
        
        list_view.separatorStyle = .none
        list_view.showsVerticalScrollIndicator = false
        list_view.register(UINib(nibName: "scv_cell", bundle: nil), forCellReuseIdentifier: "scv_cell")
        list_view.register(UINib(nibName: "two_title_cell", bundle: nil), forCellReuseIdentifier: "two_title_cell")
        list_view.register(UINib(nibName: "one_title_cell", bundle: nil), forCellReuseIdentifier: "one_title_cell")
        list_view.register(UINib(nibName: "img_title_cell", bundle: nil), forCellReuseIdentifier: "img_title_cell")
    }
    
}
