//
//  S_Y_View_Cell.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2021/2/22.
//  Copyright © 2021 junye lu. All rights reserved.
//

import UIKit
protocol S_Y_View_Cell_delegate {
    func S_Y_View_Cell_btn_click(cell:S_Y_View_Cell)
}
class S_Y_View_Cell: UITableViewCell {
    @IBOutlet weak var gys_name_lbl: UILabel!
    @IBOutlet weak var pi_ci_number_lbl: UILabel!
    @IBOutlet weak var ru_ku_time_lbl: UILabel!
    @IBOutlet weak var chan_di_lbl: UILabel!
    @IBOutlet weak var sheng_chan_ri_qi_lbl: UILabel!
    @IBOutlet weak var img_btn: UIButton!
    
    @IBOutlet weak var img: UIImageView!
    @IBOutlet weak var bao_zhi_qi_lbl: UILabel!
    var delegate:S_Y_View_Cell_delegate?
    @IBAction func img_btn_click(_ sender: UIButton) {
        delegate?.S_Y_View_Cell_btn_click(cell: self)
    }
    
    var data:OrderDetailGoodsSourceModel? {
        didSet{
            if data != nil {
                bao_zhi_qi_lbl.text = data?.valid_date
                sheng_chan_ri_qi_lbl.text = data?.production_data
                chan_di_lbl.text = data?.product_origin
                ru_ku_time_lbl.text = data?.add_time
                pi_ci_number_lbl.text = data?.batch_sn
                gys_name_lbl.text = data?.ven_name
                
                img.sd_setImage(with: URL(string:SERVERCE_ImageHost +  ((data?.report_picture?.first)!)!), placeholderImage: nil,options:.allowInvalidSSLCertificates)
                
            }
        }
    }
    override func awakeFromNib() {
        super.awakeFromNib()
        self.selectionStyle = .none
    }
    
    override func setSelected(_ selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)
        
        // Configure the view for the selected state
    }
    
}
