//
//  NewSelectItemVc.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/6/3.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
protocol NewSelectItemVcDelegate {
    func NewSelectItemVcSelect(datas:Array<InputInitInfoGoodsInfoModel>,pici:Array<Array<GetGoodBatchDataModel>>,select:Array<Int>,str:Array<String>,typeArr:Array<Int>,imgArr:Array<String>)
}
class NewSelectItemVc: BaseViewController,UITableViewDelegate,UITableViewDataSource{
    var isRuKu = false
    var rkDatas:Array<InputInitInfoGoodsInfoModel> = []
    var rkSelectArr:Array<InputInitInfoGoodsInfoModel> = []
    var select_ven_list:Array<Int> = []
    var report_sn_arr:Array<String> = []
    var report_img_arr:Array<String> = []
    var report_type_arr:Array<Int> = []
    var tempRecord:Array<Int> = []
    var recordArr:Array<Array<GetGoodBatchDataModel>>  = []{
        didSet{
            tempRecord.removeAll()
            for i in 0 ..< recordArr.count{
                tempRecord.append(i)
            }
        }
    }
    
    var delegate:NewSelectItemVcDelegate?
    
    @IBAction func submitAction(_ sender: Any) {
        if tempRecord.count > 0 {
            for i in 0 ..< tempRecord.count {
                let idx = tempRecord[i]
                if idx == 10086 {
                    recordArr.remove(at: i)
                        recordArr.append([])
                }
            }
        }
        delegate?.NewSelectItemVcSelect(datas: rkSelectArr, pici: recordArr,select:select_ven_list,str:report_sn_arr,typeArr:report_type_arr,imgArr:report_img_arr)
        self.navigationController?.popViewController(animated: true)
    }
    
    
    @IBOutlet weak var listView: UITableView!
    @IBOutlet weak var searchBg: UIView!
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = "选择商品"
        self.view.addSubview(navbar)
        listView.register(UINib(nibName: "XuanZeShangPinCell", bundle: nil), forCellReuseIdentifier: "XuanZeShangPinCell")
        listView.separatorStyle = .none
        SetTopFrame(view:searchBg,height:0)
        
        
        
        // Do any additional setup after loading the view.
    }
    
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        
        return rkDatas.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "XuanZeShangPinCell") as! XuanZeShangPinCell
        cell.tag = indexPath.row
        let cellData = rkDatas[indexPath.row]
        
        cell.tapBtn.isUserInteractionEnabled = false
        
        cell.selectBtn.isSelected = false
        
        for item in rkSelectArr {
            if item.sku_id == cellData.sku_id {
                cell.selectBtn.isSelected = true
            }
        }
        cell.iconImg.sd_setImage(with:URL(string:SERVERCE_ImageHost +  cellData.goods_thumb!), placeholderImage: nil,options:.allowInvalidSSLCertificates)
        cell.nameLbl.text = cellData.goods_name
        cell.detailLbl.text = cellData.spec_str
        cell.detailLbl2.text = "库存数:\(cellData.inventory!)"
        
        return cell
    }
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 120
    }
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        
        
        let data = rkDatas[indexPath.row]
        let idx = rkSelectArr.firstIndex { (model) -> Bool in
            return model.sku_id == data.sku_id
        }
        if idx != nil {
            rkSelectArr.remove(at: idx!)
            if select_ven_list.count > 0 {
                select_ven_list.remove(at: idx!)
                report_sn_arr.remove(at: idx!)
                report_img_arr.remove(at: idx!)
                report_type_arr.remove(at: idx!)
            }
            if !isRuKu {
                tempRecord.insert(10086, at: idx!)
                tempRecord.remove(at: idx!+1)
            }
        }else{
            rkSelectArr.append(data)
            report_sn_arr.append("")
            report_img_arr.append("")
            report_type_arr.append(-1)
            if data.ven_list?.count == 1 {
                select_ven_list.append(0)
            }else{
                select_ven_list.append(-1)
            }
        }
        listView.reloadData()
    }
    
}
