//
//  NewRKVc.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/6/2.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import LGButton
import Photos

protocol NewRKVcDelegate {
    func NewRKVcFinish()
}
class NewRKVc: BaseViewController ,UITableViewDelegate,UITableViewDataSource, NewOnlyRKCellDelegate,NewSelectItemVcDelegate,NewSelectWarehouseVCDelegate,GLAlertSelectViewDelegate,GeliAlertTextViewDelegate, ShowTimeSelectViewDelegate, GYSListViewControllerDelegate, GYSGLViewControllerDelegate, Add_Report_View_Delegate{
    func Add_Report_View_Close(view: Add_Report_View) {
        report_view?.removeFromSuperview()
        report_view = nil
    }
    
    var isCaiGou_GYS_name:String = ""
    var isCaiGou_GYS_ven_id:Int = -1
    var select_ven_list:Array<Int> = []
    
    func NewOnlyRKCell_gys_select(cell: NewOnlyRKCell) {
        if rkSelectArr[cell.tag].ven_list!.count == 0 {
            return
        }
        if isCaiGou || rkSelectArr[cell.tag].ven_list!.count == 1{
            return
        }
       
        if glSelectView == nil {
            var gys_arr:Array<String> = []
            rkSelectArr[cell.tag].ven_list?.forEach({ (item) in
                gys_arr.append(item.ven_name!)
            })
            let view = GLAlertSelectView(frame: self.view.bounds)
            view.tag = cell.tag
            view.selectNum = typeSelect
            view.tempNum = view.selectNum
            view.isOnlySelectKuWei = true
            view.delegate = self
            view.titleLbl.text = "请选择供应商"
            view.dataArr = gys_arr
            self.view.addSubview(view)
            glSelectView = view
        }
    }
    func Add_Report_View_ChangeImg(view: Add_Report_View, idx: Int) {
        _ = self.presentHGImagePicker(maxSelected:1) { (assets) in
            //结果处理
            print("共选择了\(assets.count)张图片，分别如下：")
            let option = PHImageRequestOptions()
            option.isSynchronous = true
            option.isNetworkAccessAllowed = true
            for asset in assets {
                PHImageManager.default().requestImage(for: asset, targetSize: PHImageManagerMaximumSize , contentMode:  .default , options: option, resultHandler: { (image,  _: [AnyHashable : Any]?) in
                    //                    print("上传图片==\(image)")
                    self.uploadImg(imge: image!, isOriginal: true, tag: idx)
                })
            }
        }
    }
    
    func Add_Report_View_DelImg(view: Add_Report_View, idx: Int) {
        maxFiveImgsArr.remove(at:idx)
        goods_banner?.insert("", at: 5)
        goods_banner?.remove(at: idx)
        
        report_view?.imgs_datas = maxFiveImgsArr
        report_view?.layoutIfNeeded()
    }
    var report_img_arr:Array<String> = []
    var report_type_arr:Array<Int> = []
    var report_sn_arr:Array<String> = []
    func Add_Report_View_Submit_Action(view: Add_Report_View) {
        var lastGoodsBanner:Array<String> = []
        self.goods_banner?.forEach({ (str) in
            if str.count > 0 {
                lastGoodsBanner.append(str)
            }
        })
        var goods_bannerStr:String = ""
        if lastGoodsBanner.count > 0 {
            //            goods_bannerStr = dataChangeString(sender: lastGoodsBanner)
            goods_bannerStr = lastGoodsBanner.joined(separator: ",")
        }
        report_type_arr.insert(view.select_idx!, at: view.tag)
        report_type_arr.remove(at: view.tag + 1)
        report_img_arr.insert(goods_bannerStr, at: view.tag)
        report_img_arr.remove(at: view.tag + 1)
        report_sn_arr.insert(view.report_sn_tf.text!, at: view.tag)
        report_sn_arr.remove(at: view.tag + 1)
        let model = rkSelectArr[view.tag]
        let dic = ["user_token":UserToken as Any,
                   "report_sn":report_sn_arr[view.tag] as Any,
                   "report_type":view.select_idx! + 1 as Any,
                   "goods_id":model.goods_id as Any,
                   "sku_id":model.sku_id as Any,
                   "file_url":goods_bannerStr as Any
        ]
        GoodsReportAdd(dic) { (data) in
            let model = data as! GoodsReportAddModel
            let rkModel = self.rkSelectArr[view.tag]
            rkModel.report_id = model.data?.report_id
            self.maxFiveImgsArr.removeAll()
            self.report_view?.removeFromSuperview()
            self.report_view = nil
            self.listView.reloadData()
        } failture: { (err) in
            
        }
        
    }
    
    func NewSelectItemVcSelect(datas: Array<InputInitInfoGoodsInfoModel>, pici: Array<Array<GetGoodBatchDataModel>>,select:Array<Int>,str:Array<String>,typeArr:Array<Int>,imgArr:Array<String>) {
        rkSelectArr.removeAll()
        datas.forEach { (model) in
            rkSelectArr.append(model)
        }
        report_sn_arr.removeAll()
        str.forEach { (item) in
            report_sn_arr.append(item)
        }
        
        report_img_arr.removeAll()
        imgArr.forEach { (item) in
            report_img_arr.append(item)
        }
        
        report_type_arr.removeAll()
        typeArr.forEach { (item) in
            report_type_arr.append(item)
        }
        
        select_ven_list.removeAll()
        select.forEach { (item) in
            select_ven_list.append(item)
        }
        listView.reloadData()
    }
    
    
    var maxFiveImgsArr:Array<String> = []//多图
    func Add_Report_View_Select_Img(view: Add_Report_View) {
        print("选择")
        let num = 5 - maxFiveImgsArr.count
        _ = self.presentHGImagePicker(maxSelected:num) { (assets) in
            //结果处理
            print("共选择了\(assets.count)张图片，分别如下：")
            let option = PHImageRequestOptions()
            option.isSynchronous = true
            option.isNetworkAccessAllowed = true
            for asset in assets {
                PHImageManager.default().requestImage(for: asset, targetSize: PHImageManagerMaximumSize , contentMode:  .default , options: option, resultHandler: { (image,  _: [AnyHashable : Any]?) in
                    
                    //调用上传图片
                    self.maxFiveImgsArr.append("insert")
                    self.uploadImg(imge: image!, isOriginal: false, tag: self.maxFiveImgsArr.count-1)
                    
                })
            }
            self.listView.reloadData()
        }
    }
    
    var goods_banner:Array<String>? = ["","","","",""] //商品副图，多张，最多5张，使用一维数组转json格式
    func uploadImg (imge:UIImage,isOriginal:Bool,tag:Int){
        let upLoadImg = imge
        HUD.show(.progress)
        saveFile(image: upLoadImg, ["user_token":UserToken as Any,"path":"category" as Any], success: { (data) in
            let dataM = data as! SaveFileModel
            if dataM.code == 1 {
                self.goods_banner?.insert((dataM.data?.url!)!, at: tag)
                self.goods_banner?.remove(at: tag + 1)
                self.maxFiveImgsArr.removeAll()
                self.goods_banner?.forEach({ (str) in
                    if str.count > 0 {
                        self.maxFiveImgsArr.append(str)
                    }
                })
                self.report_view?.imgs_datas = self.maxFiveImgsArr
                self.report_view?.layoutIfNeeded()
                HUD.hide()
            }
        }) { (error) in
            print("图片上传失败\(error)")
        }
    }
    
    func GYSGLViewControllerFinish() {
        //此处无用
    }
    
    var ven_id = -1
    func GYSListViewControllerGetGYS(sender: VendorListDataModel) {
        holderArr.insert(sender.ven_name!, at: 3)
        ven_id = sender.ven_id!
        holderArr.remove(at: 4)
        listView.reloadData()
    }
    
    let UserToken = UserDefaults.standard.value(forKey: "user_token")
    var delegate:NewRKVcDelegate?
    var po_id = 0
    var isCaiGou = false
    var remark = ""
    var orderNumStr = ""
    //MARK: - 提交申请
    func sureGeliAlertTextViewAction(sender: String, view: GeliAlertTextView) {
        
        remark = sender
        holderArr.insert(remark, at: holderArr.count-1)
        holderArr.remove(at: holderArr.count-1)
        listView.reloadData()
    }
    @IBAction func gmAction(_ sender: Any) {
        if gmNumber == nil {
            if holderArr[0] == "请选择仓库" {
                HUD.flash(.label("请选择仓库"), delay: 1.2)
                return
            }
            if holderArr[1] == "请选择库位" {
                HUD.flash(.label("请选择库位"), delay: 1.2)
                return
            }
        }
        if holderArr[2] == "请选择入库类型" {
            HUD.flash(.label("请选择入库类型"), delay: 1.2)
            return
        }
      
        if rkSelectArr.count == 0 {
            HUD.flash(.label("请选择商品"), delay: 1.2)
            return
        }
        
        for item in rkSelectArr{
            if  item.RKSL == nil{
                HUD.flash(.label("请填写入库数量"), delay: 1.2)
                return
            }
            if item.createDay == nil {
                HUD.flash(.label("请选择生产日期"), delay: 1.2)
                return
            }
            if item.BZQ == nil {
                HUD.flash(.label("请填写保质期"), delay: 1.2)
                return
            }
            if item.report_id == nil {
                HUD.flash(.label("请提交检测报告"), delay: 1.2)
                return
            }
        }
        HUD.show(.progress)
        if lgBtnTitLbl.text != "提交申请"{
            var goodsInfoArr:Array<Any>? = []
            for i in 0 ..< rkSelectArr.count {
                let model = rkSelectArr[i]
                var rkjg:Float = 0
                var total:Float = 0
                if model.RKJG != nil {
                    rkjg = model.RKJG!
                    if model.RKSL != nil {
                        total = rkjg * Float(model.RKSL!)
                    }
                }
                
                var shelf_life = model.BZQ
                if model.DayType == 0 {
                    shelf_life = model.BZQ! * 30
                }
                var ven_id = 0
                if select_ven_list[i] != -1 {
                    let mo = model.ven_list![select_ven_list[i]]
                    ven_id = mo.ven_id!
                }
                let goods = [
                    "goods_id":model.goods_id as Any,
                    "sku_id":model.sku_id as Any,
                    "goods_name":model.goods_name as Any,
                    "goods_spec":model.spec_str as Any,
                    "number":model.RKSL as Any,
                    "price":model.price as Any,
                    "amount":rkjg as Any,
                    "subtotal":total as Any,
                    "production_data":model.createDay as Any,
                    "shelf_life":shelf_life as Any,
                    "report_id":model.report_id as Any,
                    "pog_id":model.pog_id as Any,
                    "ven_id":ven_id as Any
                ]
                goodsInfoArr?.append(goods)
            }
            
            let goods_info = dataChangeString(sender: goodsInfoArr!)
            let dict = [
                "user_token":UserToken as Any,
                "w_id":w_id as Any,
                "p_id":p_id as Any,
                "i_type":typeSelect + 8 as Any,
                "apply_remark":remark as Any,
                "po_id":po_id as Any,
                "ven_id":ven_id as Any,
                "g_type":selectTypeSelect + 1 as Any,
                "goods_info":goods_info as Any
            ]
            GoodsInput(dict, success: { (data) in
                HUD.hide()
                HUD.flash(.labeledSubSuccess(subtitle: "入库成功"), delay: 1.2)
                self.delegate?.NewRKVcFinish()
                self.navigationController?.popViewController(animated: true)
                
            }) { (error) in
                
            }
        }else{
            var goodsInfoArr:Array<Any>? = []
            for i in 0 ..< rkSelectArr.count {
                let model = rkSelectArr[i]
                var total:Float = 0
                total = model.RKJG! * Float(model.RKSL!)
                
                var shelf_life = model.BZQ
                if model.DayType == 0 {
                    shelf_life = model.BZQ! * 30
                }
                
                var ven_id = 0
                if select_ven_list[i] != -1 {
                    let mo = model.ven_list![select_ven_list[i]]
                    ven_id = mo.ven_id!
                }
                let goods = [
                    "goods_id":model.goods_id as Any,
                    "sku_id":model.sku_id as Any,
                    "goods_name":model.goods_name as Any,
                    "goods_spec":model.spec_str as Any,
                    "number":model.RKSL! as Any,
                    "price":model.price as Any,
                    "amount":model.RKJG! as Any,
                    "subtotal":total as Any,
                    "production_data":model.createDay as Any,
                    "shelf_life":shelf_life as Any,
                    "report_id":0 as Any,
                    "pog_id":model.pog_id as Any,
                    "ven_id":ven_id as Any
                ]
                goodsInfoArr?.append(goods)
            }
            let goods_info = dataChangeString(sender: goodsInfoArr!)
            let dict = [
                "user_token":UserToken as Any,
                "i_type":typeSelect + 8 as Any,
                "apply_remark":remark as Any,
                "po_id":po_id as Any,
                "ven_id":ven_id as Any,
                "g_type":selectTypeSelect + 1 as Any,
                "goods_info":goods_info as Any
            ]
            
            GoodsInputApply(dict, success: { (data) in
                HUD.hide()
                HUD.flash(.labeledSubSuccess(subtitle: "申请成功"), delay: 1.2)
                self.delegate?.NewRKVcFinish()
                self.navigationController?.popViewController(animated: true)
                
            }) { (error) in
                
            }
        }
    }
    
    var gmNumber:Int?
    
    var sku_id:Int?
    var goods_id:Int?
    @IBOutlet weak var lgBtnTitLbl: UILabel!
    @IBOutlet weak var lgBtn: LGButton!
    var isGm = false
    var titleArr = ["仓库：","库位：","入库类型：","备注："]
    var holderArr = ["请选择仓库","请选择库位","固定采购","请输入备注"]
    //    var titleArr = ["仓库：","库位：","入库类型：","选择供应商：","选择商品类型：","备注："]
    //    var holderArr = ["请选择仓库","请选择库位","直营入库","请选择供应商","直销商品","请输入备注"]
    //入库类型 // "固定采购","临时采购"
    //    var rkTypeArr = ["采购","调入","退货","生产","调出被拒绝","外采","其他","直营入库"]
    var rkTypeArr = ["固定采购","临时采购","直营入库"]
    var rkSelectTypeArr = ["直销商品","代销商品"]
    var typeSelect:Int = 0
    var selectTypeSelect:Int = 0
    
    var glSelectView:GLAlertSelectView?
    
    var poiArr:Array<ShopWarehouseDetailDataPositionModel> = []
    
    @IBOutlet weak var btmView: UIView!
    @IBOutlet weak var listView: UITableView!
    
    var rkSelectArr:Array<InputInitInfoGoodsInfoModel> = []//产品选择
    var rkDatas:Array<InputInitInfoGoodsInfoModel> = []//产品
    
    var rkWareHouseArr:Array<InputInitInfoWareHouseResModel> = []//库位选择
    var selectIdx:Int?//库位选择
    
    var authArr:Array<String> = []//权限
    
    var w_id:Int?
    var p_id:Int?
    func rightBtnClick() {
        print("新增供应商")
        let vc = GYSGLViewController()
        vc.delegate = self
        vc.barT = "新增供应商信息"
        self.navigationController?.pushViewController(vc, animated: true)
    }
    override func viewDidLoad() {
        super.viewDidLoad()
        
        if orderNumStr.count > 0 {
            titleArr.append("采购单号：")
            holderArr.append(orderNumStr)
        }
        
        if isCaiGou {
            typeSelect = 0
            holderArr.insert(rkTypeArr[typeSelect], at: 2)
            holderArr.remove(at: 3)
        }
        
        //        let strNowTime = getTimeNow()
        //        holderArr.insert(strNowTime, at: 3)
        //        holderArr.remove(at: 4)
        
        navbar.title = "入库"
        self.view.addSubview(navbar)
        SetTopFrameView(view: listView, btmView: btmView)
        navbar.rightTitle = "新增供应商"
        listView.separatorStyle = .none
        
        listView.register(UINib(nibName: "CRKBtnCell", bundle: nil), forCellReuseIdentifier: "CRKBtnCell")
        listView.register(UINib(nibName: "NewOnlyRKCell", bundle: nil), forCellReuseIdentifier: "NewOnlyRKCell")
        listView.register(UINib(nibName: "TitleAndLblCell", bundle: nil), forCellReuseIdentifier: "TitleAndLblCell")
        
        loadData()
        // Do any additional setup after loading the view.
    }
    
    func loadData(){
        HUD.flash(.progress)
        listView.isHidden = true
        lgBtn.isHidden = true
        lgBtnTitLbl.isHidden = true
        InputInitInfo(["user_token":UserToken as Any,"goods_id":goods_id as Any], success: { (data) in
            let model = data as! InputInitInfoModel
            
            model.data?.auth?.forEach({ (str) in
                self.authArr.append(str)
            })
            model.data?.warehouse_res?.forEach({ (item) in
                if item.is_default == 1 {
                    self.holderArr.insert(item.w_name!, at: 0)
                    self.holderArr.remove(at: 1)
                    
                    self.w_id = item.w_id
                    
                    item.warehouse_position?.forEach({ (data) in
                        if data.is_default == 1 {
                            self.p_id = data.p_id
                            self.holderArr.insert(data.p_name!, at: 1)
                            self.holderArr.remove(at: 2)
                        }
                    })
                }
            })
            
            
            if self.authArr.contains("63") == false && self.authArr.contains("65") == false {
                self.listView.isHidden = true
                self.lgBtn.isHidden = true
                self.lgBtnTitLbl.isHidden = true
                HUD.flash(.label("亲，您不具备编辑的权限"), delay:1.2)
                return
            }
            
            if self.gmNumber != nil{//入库申请
                var pass = false
                self.authArr.forEach { (str) in
                    if str == "\(self.gmNumber!)"{
                        self.lgBtnTitLbl.text = "提交申请"
                        pass = true
                    }
                }
                if pass == false {
                    self.listView.isHidden = true
                    self.lgBtn.isHidden = true
                    self.lgBtnTitLbl.isHidden = true
                    HUD.flash(.label("亲，您不具备编辑的权限"), delay:1.2)
                    return
                }
            }else{
                self.lgBtnTitLbl.text = "提交申请"
                if self.authArr.contains("63"){
                    self.isGm = true
                    self.lgBtnTitLbl.text = "直接入库"
                }
            }
            
            
            
            model.data?.warehouse_res?.forEach({ (item) in
                self.rkWareHouseArr.append(item)
            })
            model.data?.goods_info?.forEach({ (item) in
                if item.sku_id == self.sku_id {
                    self.rkSelectArr.append(item)
                    
                }
                self.rkDatas.append(item)
            })
            
            self.report_sn_arr.removeAll()
            self.select_ven_list.removeAll()
            self.report_img_arr.removeAll()
            self.report_type_arr.removeAll()
            
            self.rkSelectArr.forEach { (item) in
                self.report_img_arr.append("")
                self.report_type_arr.append(-1)
                self.report_sn_arr.append("")
                if item.ven_list?.count == 1 {
                    self.select_ven_list.append(0)
                }else{
                    self.select_ven_list.append(-1)
                }
            }
            
            self.listView.reloadData()
            HUD.hide()
            self.listView.isHidden = false
            self.lgBtn.isHidden = false
            self.lgBtnTitLbl.isHidden = false
        }) { (error) in
            
        }
    }
    
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        if indexPath.section == 1 {
            return
        }
        //        if indexPath.row == 3 {
        //            print("选择供应商")
        //            let vc = GYSListViewController()
        //            vc.barTitle = "选择供应商"
        //            vc.delegate = self
        //            self.navigationController?.pushViewController(vc, animated: true)
        //        }
        //        if indexPath.row == 4 {
        //            if isCaiGou  == false{
        //                if glSelectView == nil {
        //                    let view = GLAlertSelectView(frame: self.view.bounds)
        //                    view.tag = indexPath.row
        //                    view.selectNum = selectTypeSelect
        //                    view.isOnlySelectKuWei = true
        //                    view.delegate = self
        //                    view.titleLbl.text = "选择商品类型"
        //                    view.dataArr = rkSelectTypeArr
        //                    self.view.addSubview(view)
        //                    glSelectView = view
        //                }
        //            }
        //        }
        if indexPath.row == 3 {
            let alterView = GeliAlertTextView(frame: self.view.window!.bounds)
            alterView.delegate = self
            alterView.titleLbl.text = "请填写入库备注"
            alterView.placerLbl.text = "请填写入库备注..."
            if remark.count > 0 {
                alterView.textview.text = remark
                alterView.placerLbl.isHidden = true
            }
            self.view.window?.addSubview(alterView)
        }
        if indexPath.row == 2 {
            if isCaiGou  == false{
                if glSelectView == nil {
                    let view = GLAlertSelectView(frame: self.view.bounds)
                    view.tag = indexPath.row
                    view.selectNum = typeSelect
                    view.tempNum = view.selectNum
                    view.isOnlySelectKuWei = true
                    view.delegate = self
                    view.titleLbl.text = "请选择入库类型"
                    view.dataArr = rkTypeArr
                    self.view.addSubview(view)
                    glSelectView = view
                }
            }
        }
        if indexPath.row == 0 {
            let vc = NewSelectWarehouseVC()
            vc.rkWareHouseArr = rkWareHouseArr
            vc.delegate = self
            self.navigationController?.pushViewController(vc, animated: true)
        }
        if indexPath.row == 1 {
            
            if poiArr.count > 0 {
                if glSelectView == nil {
                    let view = GLAlertSelectView(frame: self.view.bounds)
                    if selectIdx != nil {
                        view.selectNum = selectIdx
                        view.tempNum = view.selectNum
                    }
                    view.isOnlySelectKuWei = true
                    view.delegate = self
                    view.titleLbl.text = "请选择库位"
                    var pArr:Array<String> = []
                    for item in poiArr {
                        let str = item.p_name! + "(库存数:\(item.inventory_count!))"
                        pArr.append(str)
                    }
                    
                    view.dataArr = pArr
                    self.view.addSubview(view)
                    glSelectView = view
                }
            }else{//待
                if w_id != nil {
                    
                    WarehouseDetail(["user_token":UserToken as Any,"w_id":w_id as Any], success: { (data) in
                        let model = data as! ShopWarehouseDetailModel
                        model.data?.position_res?.forEach({ (item) in
                            self.poiArr.append(item)
                        })
                        if self.glSelectView == nil {
                            let view = GLAlertSelectView(frame: self.view.bounds)
                            
                            view.isOnlySelectKuWei = true
                            view.delegate = self
                            view.titleLbl.text = "请选择库位"
                            var pArr:Array<String> = []
                            for i in 0 ..< self.poiArr.count {
                                let item = self.poiArr[i]
                                let str = item.p_name! + "(库存数:\(item.inventory_count!))"
                                if item.p_id == self.p_id {
                                    self.selectIdx = i
                                }
                                pArr.append(str)
                            }
                            
                            view.selectNum = self.selectIdx
                            view.tempNum = view.selectNum
                            
                            view.dataArr = pArr
                            self.view.addSubview(view)
                            self.glSelectView = view
                        }
                    }) { (error) in
                        
                    }
                    
                }else{
                    HUD.flash(.label("请选择仓库"), delay: 1.2)
                }
            }
        }
    }
    //MARK: - cellForRow
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        if indexPath.section == 1{
            let cell = tableView.dequeueReusableCell(withIdentifier: "NewOnlyRKCell") as! NewOnlyRKCell
            cell.tag = indexPath.row
            cell.delegate = self
            if isCaiGou {
                cell.delBtn.isHidden = true
            }
            let data = rkSelectArr[indexPath.row]
            cell.nameLbl.text = data.goods_name
            if data.no_push_num != nil {
                cell.titLbl.text = "入库数量：(可入库量为" + StringByInt(number: data.no_push_num!) 
            }
            cell.detailLbl.text = data.spec_str! + " ¥" + data.price!
            cell.rkPriceTf.text = data.price!
            cell.rkCountTf.text = "1"
            cell.bzqTf.text = ""
            cell.timeLbl.text = "请选择生产日期"
            if data.RKJG != nil {
                cell.rkPriceTf.text = String(format: "%.2f", data.RKJG!)
            }else{
                data.RKJG = Float(data.price!)
            }
            if data.RKSL != nil {
                cell.rkCountTf.text = String(format: "%d", data.RKSL!)
            }else{
                cell.rkCountTf.text = "1"
                data.RKSL = 1
            }
            if data.ZJ != nil {
                cell.totalPriceTf.text = String(format: "%.2f", data.ZJ!)
            }else{
                cell.totalPriceTf.text = data.price!
            }
            if data.BZQ != nil {
                cell.bzqTf.text = String(format: "%d", data.BZQ!)
            }
            
            if data.DayType == 0 {
                cell.rightBtn.isSelected = true
                cell.leftBtn.isSelected = false
            }
            if data.createDayStr != nil {
                cell.timeLbl.text = data.createDayStr
            }
            let report_sn = report_sn_arr[indexPath.row]
            if report_sn.count != 0 {
                cell.btn_title_lbl.text = "查看"
            }
            cell.gys_name_lbl.text = "请选择供应商"
            cell.gys_arrow.isHidden = false
            cell.gys_right_margin.constant = 10
            
            if isCaiGou_GYS_ven_id != -1 {
                cell.gys_name_lbl.text = isCaiGou_GYS_name
                cell.gys_arrow.isHidden = true
                cell.gys_right_margin.constant = -7
            }
            if data.ven_list?.count == 1 {
                let mo = data.ven_list?.first
                cell.gys_name_lbl.text = mo?.ven_name
                cell.gys_arrow.isHidden = true
                cell.gys_right_margin.constant = -7
            }else{
                if select_ven_list.count > 0 {
                    if select_ven_list[indexPath.row] != -1 {
                        let mo = data.ven_list![select_ven_list[indexPath.row]]
                        cell.gys_name_lbl.text = mo.ven_name
                        cell.gys_arrow.isHidden = true
                        cell.gys_right_margin.constant = -7
                    }
                }
            }
            
            return cell
        }
        
        if indexPath.row == 3 {
            let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndLblCell") as! TitleAndLblCell
            cell.nameLbl.text = titleArr[indexPath.row]
            if orderNumStr.count == 0 {
                cell.btmLine.isHidden = true
            }
            cell.contentLbl.text = holderArr[indexPath.row]
            cell.btmW.constant = 0
            cell.contentRight.constant = 0
            cell.imgRight.constant = 15
            cell.contentLbl.textColor = UIColor(named: "#999999")
            if remark.count != 0 {
                cell.contentLbl.text = remark
                cell.btmW.constant = 15
                cell.contentRight.constant = 5
                cell.imgRight.constant = 22
                cell.contentLbl.textColor = UIColor(named: "标题字颜色")
            }
            return cell
        }
        
        let cell = tableView.dequeueReusableCell(withIdentifier: "CRKBtnCell") as! CRKBtnCell
        cell.tag = indexPath.row
        cell.nameLbl.text = titleArr[indexPath.row]
        cell.contentLbl.text = holderArr[indexPath.row]
        cell.mustLbl.isHidden = true
        cell.nameLeft.constant = 0
        cell.mustWidth.constant = 0
        if indexPath.row > 2 {
            setCellUI(cell: cell)
        }
        return cell
        
    }
    //MARK: - 入库商品delegate
    func NewOnlyRKCellDateTypeSelect(sender: Int, cell: NewOnlyRKCell) {
        // 0:月， 1:天
        let data = rkSelectArr[cell.tag]
        data.DayType = sender
    }
    
    //MARK:---跳转日期选择
    var tempTag:Int?
    func NewOnlyRKCellDateSelect(cell: NewOnlyRKCell) {
        print("跳转日期选择")
        let timeSelectV = ShowTimeSelectView(frame: self.view.window!.bounds)
        timeSelectV.moreSelection = false
        tempTag = cell.tag
        let data = rkSelectArr[tempTag!]
        //把默认值传回去
        if data.createDay != nil {
            let time = TimeInterval(exactly: data.createDay!)
            timeSelectV.BeginDate = Date(timeIntervalSince1970: time!)
            timeSelectV.EndDate = Date(timeIntervalSince1970: time!)//无用处
            
        }
        
        timeSelectV.endDateByWork = Date()
        timeSelectV.titleLbl.text = "请选择生产日期"
        timeSelectV.delegate = self
        self.view.window?.addSubview(timeSelectV)
    }
    //MARK:--选择时间回调数据
    func showTimeSelectByData(timeStr: String, beginDate: Date, endginDate: Date) {
        let timeInterval:TimeInterval = beginDate.timeIntervalSince1970
        
        let data = rkSelectArr[tempTag!]
        data.createDay = Int(timeInterval)
        data.createDayStr = timeStr
        listView.reloadData()
    }
    var report_view:Add_Report_View?
    
    func NewOnlyRKCellAddRepord(cell: NewOnlyRKCell) {
        //添加检测报告
        print("添加检测报告")
        if report_view == nil {
            let vc = Add_Report_View(frame: self.view.bounds)
            vc.delegate = self
            let sn = report_sn_arr[cell.tag]
            if sn.count != 0 {
                vc.report_sn_tf.text = sn
            }
            let idx = report_type_arr[cell.tag]
            if idx != -1 {
                vc.select_idx = idx
            }
            let imglnks = report_img_arr[cell.tag]
            maxFiveImgsArr.removeAll()
            if imglnks.count != 0 {
                vc.imgs_datas = imglnks.components(separatedBy: ",")
                vc.imgs_datas.forEach { (item) in
                    maxFiveImgsArr.append(item)
                }
            }
            
            vc.tag = cell.tag
            self.view.addSubview(vc)
            report_view = vc
            report_view?.layoutIfNeeded()
        }
    }
    
    func NewOnlyRKCellDel(cell: NewOnlyRKCell) {
        //删除
        rkSelectArr.remove(at: cell.tag)
        select_ven_list.remove(at: cell.tag)
        report_sn_arr.remove(at: cell.tag)
        report_img_arr.remove(at: cell.tag)
        report_type_arr.remove(at: cell.tag)
        listView.reloadData()
    }
    
    func NewOnlyRKCellTFinput(text: String, inputType: Int, cell: NewOnlyRKCell) {
        //text:数据  inputType: 100-保质期 101-总价 102-入库数量 103-入库价格
        let num = text as NSString
        let data = rkSelectArr[cell.tag]
        switch inputType {
        case 100:
            data.BZQ = num.integerValue
            break
        case 101:
            let value = String(format:"%.2f", num.floatValue)
            data.ZJ = Float(value)
            break
        case 102:
            if num.integerValue == 0 {
                HUD.flash(.label("入库数量不小于1"), delay: 1.2)
                data.RKSL = 1
                let idx = IndexPath(row: cell.tag, section: 1)
                listView.reloadRows(at: [idx], with: .none)
            }else{
                data.RKSL = num.integerValue
            }
            if data.RKJG != nil && data.RKSL != nil {
                data.ZJ = data.RKJG! * Float(data.RKSL!)
                cell.totalPriceTf.text = String(format: "%.2f", data.ZJ!)
            }
            break
        case 103:
            data.RKJG = num.floatValue
            if data.RKJG != nil && data.RKSL != nil {
                data.ZJ = data.RKJG! * Float(data.RKSL!)
                cell.totalPriceTf.text = String(format: "%.2f", data.ZJ!)
            }
            break
        default:
            break
        }
    }
    
    //添加商品
    @objc func addProduct(){
        let vc = NewSelectItemVc()
        vc.delegate = self
        vc.isRuKu = true
        vc.rkDatas = rkDatas
        vc.rkSelectArr = rkSelectArr
        vc.select_ven_list = select_ven_list
        vc.report_sn_arr = report_sn_arr
        vc.report_img_arr = report_img_arr
        vc.report_type_arr = report_type_arr
        self.navigationController?.pushViewController(vc, animated: true)
    }
    //    func getStrHeight(str:String) -> CGFloat{
    //        let lbl = UILabel()
    //        lbl.text = titleArr.last
    //        lbl.font = UIFont.systemFont(ofSize: 13)
    //        lbl.sizeToFit()
    //        let margin = lbl.bounds.size.width + 77
    //        let viewSize = CGSize(width:fullScreenWidth - margin , height: CGFloat(MAXFLOAT))
    //        let font = UIFont.systemFont(ofSize: 13)
    //        return (str as NSString).boundingRect(with: viewSize, options: [.usesLineFragmentOrigin], attributes: [NSAttributedString.Key.font:font], context: nil).height
    //    }
    //MARK: - cell delegate
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        if indexPath.section == 0 {
            if isGm == false {
                if indexPath.row < 2{
                    return 0.001
                }
            }
            if indexPath.row == 5 {
                return UITableView.automaticDimension
            }
            return 49
        }
        
        return 424
    }
    func setCellUI(cell:CRKBtnCell){
        cell.contentLbl.textColor = UIColor(named: "标题字颜色")
        cell.arrowImg.isHidden = true
        cell.contentRight.constant = -7
        
    }
    func tableView(_ tableView: UITableView, viewForFooterInSection section: Int) -> UIView? {
        if section == 0 {
            let view = UIView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 10))
            view.backgroundColor = UIColor(named: "app底色")
            return view
        }
        if isCaiGou == false {
            let view = UIView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 147.5))
            let img = UIImageView()
            view.addSubview(img)
            img.image = UIImage(named: "tianjiashangpin")
            img.snp.makeConstraints { (make) in
                make.top.equalTo(30)
                make.width.height.equalTo(52)
                make.centerX.equalTo(view.snp_centerX)
            }
            let btn = UIButton()
            view.addSubview(btn)
            btn.snp.makeConstraints { (make) in
                make.top.left.right.bottom.equalTo(0)
            }
            btn.addTarget(self, action: #selector(addProduct), for: .touchUpInside)
            return view
        }else{
            let view = UIView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 10))
            view.backgroundColor = UIColor(named: "app底色")
            return view
        }
    }
    
    func tableView(_ tableView: UITableView, heightForFooterInSection section: Int) -> CGFloat {
        if section == 0 {
            return 10
        }
        if isCaiGou == false {
            return 147.5
        }
        return 0.001
    }
    func tableView(_ tableView: UITableView, viewForHeaderInSection section: Int) -> UIView? {
        if section == 1 {
            let view = UIView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 39))
            let lbl = UILabel(frame: CGRect(x: 15, y: 15, width: fullScreenWidth, height: 21))
            lbl.text = "选择商品"
            lbl.textColor = UIColor(named: "标题字颜色")
            lbl.font = UIFont.boldSystemFont(ofSize: 15)
            lbl.sizeToFit()
            view.addSubview(lbl)
            
            if rkSelectArr.count > 0 {
                let lbl2 = UILabel(frame: CGRect(x: lbl.frame.maxX + 5, y: 16, width: fullScreenWidth, height: 18.5))
                lbl2.text = "(共\(rkSelectArr.count)件)"
                lbl2.textColor = UIColor(named: "标题字颜色")
                lbl2.font = UIFont.boldSystemFont(ofSize: 13)
                view.addSubview(lbl2)
            }
            return view
        }
        return UIView()
    }
    
    func tableView(_ tableView: UITableView, heightForHeaderInSection section: Int) -> CGFloat {
        if section == 1 {
            if rkSelectArr.count > 0 {
                return 49
            }
            return 39
        }
        return 0.001
    }
    
    func numberOfSections(in tableView: UITableView) -> Int {
        return 2
    }
    
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        if section == 0 {
            return titleArr.count
        }
        return rkSelectArr.count
    }
    func NewSelectWarehouseVCFinish(kuWeiArr: Array<ShopWarehouseDetailDataPositionModel>, data: InputInitInfoWareHouseResModel) {
        holderArr.insert(data.w_name!, at: 0)
        holderArr.remove(at: 1)
        if w_id != data.w_id {
            holderArr.insert("请选择库位", at: 1)
            holderArr.remove(at: 2)
            w_id = data.w_id
        }
        poiArr.removeAll()
        kuWeiArr.forEach { (item) in
            poiArr.append(item)
        }
        listView.reloadData()
    }
    
    
    func GLASClose(view: GLAlertSelectView, selectnum: Int, selectArr: Array<Int>) {
        if view.tag == 2 {
            typeSelect = selectnum
        }else if view.tag == 4 {
            selectTypeSelect = selectnum
        }else{
            selectIdx = selectnum
        }
        view.removeFromSuperview()
        glSelectView = nil
    }
    
    func GLAlertSelectViewClick(selectNum: Int, view: GLAlertSelectView) {
        
        if view.titleLbl.text == "请选择供应商"{
            select_ven_list.insert(selectNum, at: view.tag)
            select_ven_list.remove(at: view.tag + 1)
            glSelectView?.removeFromSuperview()
            glSelectView = nil
            listView.reloadData()
            return
        }
        if view.tag == 2 {
            typeSelect = selectNum
            holderArr.insert(rkTypeArr[typeSelect], at: 2)
            holderArr.remove(at: 3)
        }else if view.tag == 4 {
        }else{
            selectIdx = selectNum
            let data = poiArr[selectIdx!]
            p_id = data.p_id
            holderArr.insert(data.p_name!, at: 1)
            holderArr.remove(at: 2)
        }
        glSelectView?.removeFromSuperview()
        glSelectView = nil
        listView.reloadData()
    }
    @IBAction func actionClick(_ sender: UIButton) {
    }
}
