//
//  PiCiXuanZeViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/28.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
protocol PiCiXuanZeViewControllerDelegate1 {
    func PiCiXuanZeViewControllerPiCiSelect(data:Array<GetGoodBatchDataModel>,p_id:Int)
}
class PiCiXuanZeViewController1: BaseViewController,UITableViewDelegate,UITableViewDataSource, NewPiCiCellDelegate{
    func NewPiCiXuanZeCellBtnTextChange(sender: String, cell: NewPiCiCell) {
        let num = sender as NSString
        let data = dataArray[cell.tag]
        data.chuHuoLiang = num.integerValue
    }
    
    func NewPiCiXuanZeCellBtnSelect(cell: NewPiCiCell) {
        //已选择cell
        if selectArr.contains(cell.tag){
            let idx = selectArr.index(of: cell.tag)
            selectArr.remove(at: idx!)
        }else{
            selectArr.append(cell.tag)
        }
        //数据
        let data = dataArray[cell.tag]
        let idx = recordArr.firstIndex { (model) -> Bool in
            return data.batch_id == model.batch_id
        }
        if idx != nil {
            recordArr.remove(at: idx!)
        }else{
            recordArr.append(data)
        }
        
//        totalCount = 0
        
//        for item in recordArr{
//            if item.chuHuoLiang != nil {
//                totalCount += item.chuHuoLiang!
//            }
//        }
//        count_Lbl.text = StringByInt(number: totalCount)
        
    }
    
    func NewPiCiXuanZeCellRefreshCount(cell: NewPiCiCell) {
        if selectArr.contains(cell.tag) == false {
            selectArr.append(cell.tag)
        }
        print(selectArr.count)
        let data = dataArray[cell.tag]
        let idx = recordArr.firstIndex { (model) -> Bool in
            return data.batch_id == model.batch_id
        }
        if idx == nil {
            recordArr.append(data)
        }
        print(recordArr.count)
//        totalCount = 0
//        for item in selectArr{
//            let data = dataArray[item]
//            if data.chuHuoLiang != nil {
//                print(data.chuHuoLiang)
//                totalCount += data.chuHuoLiang!
//            }
//        }
//        count_Lbl.text = StringByInt(number: totalCount)
        listView.reloadData()
    }
    
    func NewPiCiCellScrollAction(x: CGFloat) {
        let cells = listView.visibleCells
        cells.forEach { (item) in
            let cell = item as! NewPiCiCell
            cell.scroll_view.setContentOffset(CGPoint(x: x, y: 0), animated: false)
        }
        scroll_view.setContentOffset(CGPoint(x: x, y: 0), animated: false)
    }
    
    
    @IBOutlet weak var top_bg_view: UIView!
    
    var first = true
    var p_id:Int?
    var sku_id:Int?
    var tag:Int?
    var totalCount = 0
    var selectArr:Array<Int> = []
    var recordArr:Array<GetGoodBatchDataModel> = []
    @IBOutlet weak var count_Lbl: UILabel!
    var dataArray:Array<GetGoodBatchDataModel> = []
    @IBOutlet weak var topView: UIView!
    @IBOutlet weak var btmLbl: UILabel!
    var delegate:PiCiXuanZeViewControllerDelegate1?
    @IBAction func submitAction(_ sender: Any) {
        for item in recordArr {
            if item.chuHuoLiang == nil {
                HUD.flash(.label("请输入数量"), delay: 1.2)
                return
            }
        }
        
        
        var temp = 0
        for model in dataArray {
            for item in recordArr {
                if model.batch_id == item.batch_id {
                    if model.chuHuoLiang != nil {
                        item.chuHuoLiang = model.chuHuoLiang
                        temp += item.chuHuoLiang!
                    }
                }
            }
        }
        if temp > totalCount {
            HUD.flash(.label("超出下单数量"), delay: 1.2)
            return
        }
        delegate?.PiCiXuanZeViewControllerPiCiSelect(data: recordArr,p_id: tag!)
        self.navigationController?.popViewController(animated: true)
    }
    let scroll_view = UIScrollView()
    
    func setTextFrame(lbl:UILabel){
        lbl.textColor = UIColor(named: "标题字颜色")
        lbl.font = UIFont.systemFont(ofSize: 13)
        lbl.textAlignment = .center
    }
    
    
    @IBOutlet weak var listView: UITableView!
    override func viewDidLoad() {
        super.viewDidLoad()
        if recordArr.count == 0 {
            first = false
        }
        navbar.title = "批次选择"
        self.view.addSubview(navbar)
        topView.snp.makeConstraints { (make) in
            make.top.equalTo(NavCGRect.height)
            make.left.right.equalTo(0)
            make.height.equalTo(44)
        }
        
        let dateLbl = UILabel()
        let nameLbl = UILabel()
        let SLLbl = UILabel()
        let inputLbl = UILabel()
        let statusLbl = UILabel()
        
        scroll_view.bounces = false
        top_bg_view.addSubview(scroll_view)
        scroll_view.snp.makeConstraints { (make) in
            make.top.left.right.bottom.equalToSuperview()
        }
        scroll_view.contentSize = CGSize(width: 448, height: 49)
        scroll_view.showsHorizontalScrollIndicator = false
        scroll_view.showsVerticalScrollIndicator = false
        scroll_view.addSubview(nameLbl)
        scroll_view.addSubview(dateLbl)
        scroll_view.addSubview(SLLbl)
        scroll_view.addSubview(inputLbl)
        scroll_view.addSubview(statusLbl)
        scroll_view.delegate = self
        
        setTextFrame(lbl: nameLbl)
        nameLbl.frame = CGRect(x: 0, y: 0, width: 95, height: 49)
        nameLbl.text = "格利批次号"
        setTextFrame(lbl: SLLbl)
        SLLbl.frame = CGRect(x: 95, y: 0, width: 92, height: 49)
        SLLbl.text = "现有库存"
        setTextFrame(lbl: inputLbl)
        inputLbl.frame = CGRect(x: SLLbl.frame.maxX, y: 0, width:100, height: 49)
        inputLbl.text = "出库数"
        setTextFrame(lbl: statusLbl)
        statusLbl.frame = CGRect(x: inputLbl.frame.maxX, y: 0, width: 66, height: 49)
        statusLbl.text = "状态"
        setTextFrame(lbl: dateLbl)
        dateLbl.frame = CGRect(x: statusLbl.frame.maxX , y: 0, width: 95, height: 49)
        dateLbl.text = "生产日期"
        
        
        
        
        listView.separatorStyle = .none
        
        listView.register(UINib(nibName: "NewPiCiCell", bundle: nil), forCellReuseIdentifier: "NewPiCiCell")
//        listView.register(UINib(nibName: "CRKSumCell", bundle: nil), forCellReuseIdentifier: "CRKSumCell")
        let UserToken = UserDefaults.standard.value(forKey: "user_token")
        let dic = ["user_token":UserToken as Any,"sku_id":sku_id as Any]
        
        listView.isHidden = true
        HUD.flash(.progress)
        GetGoodBatch(dic, success: { (data) in
            let model = data as! GetGoodBatchModel
            model.data?.forEach({ (item) in
                self.dataArray.append(item)
            })
            if self.recordArr.count > 0 {
                for item in self.dataArray{
                    for model in self.recordArr{
                        if item.batch_id == model.batch_id{
                            item.chuHuoLiang = model.chuHuoLiang
                        }
                    }
                }
            }
            self.listView.reloadData()
            self.listView.isHidden = false
            HUD.hide()
        }) { (error) in
            
        }
        
//        totalCount = 0
//        if recordArr.count > 0 {
//            for item in recordArr{
//                totalCount += item.chuHuoLiang!
//            }
//        }
        count_Lbl.text = StringByInt(number: totalCount)
    }
    
    
    //MARK: - CELL DELEGATE
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 49
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        if section == 1 {
            return 1
        }
        return dataArray.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
//        if indexPath.section == 1 {
//            let cell = tableView.dequeueReusableCell(withIdentifier: "CRKSumCell") as! CRKSumCell
//
//            cell.countLbl.text = "\(totalCount)"
//            return cell
//        }
        
        
        let cell = tableView.dequeueReusableCell(withIdentifier: "NewPiCiCell") as! NewPiCiCell
        cell.tag = indexPath.row
        let model = dataArray[indexPath.row]
        cell.delegate = self
        var name = ""
        cell.statusLbl.textColor = UIColor(named: "标题字颜色")
        switch model.status {
        case 1:
            name = "正常"
            break
        case 2:
            name = "临期"
            break
        default:
            cell.statusLbl.textColor = UIColor(named: "#F57575")
            name = "过期"
            break
        }
        cell.statusLbl.text = name
        cell.SLLbl.text = "\(model.inventory!)"
        cell.dateLbl.text = dayByDouble(sender: model.production_data!)
        if model.production_data == 0 {
            cell.dateLbl.text = "-"
        }
        cell.nameLbl.text = model.batch_sn
        
        if recordArr.count > 0 {
            for item in recordArr {
                if model.batch_id == item.batch_id {
                    if item.chuHuoLiang != nil {
                        cell.textTf.text = "\(item.chuHuoLiang!)"
                        if model.chuHuoLiang != nil{
                            cell.textTf.text = "\(model.chuHuoLiang!)"
                        }
                    }
                    cell.select_btn.isSelected = true
                    if first {
                        first = false
                        selectArr.append(cell.tag)
                    }
                }
            }
        }
        
        return cell
    }
    
    func numberOfSections(in tableView: UITableView) -> Int {
        return 1
    }
    
    func tableView(_ tableView: UITableView, viewForFooterInSection section: Int) -> UIView? {
        return UIView()
    }
    func tableView(_ tableView: UITableView, heightForFooterInSection section: Int) -> CGFloat {
        return 10
    }
    
}
