//
//  FXYGL_ViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/12/30.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit

class FXYGL_ViewController: BaseViewController, UISearchBarDelegate, SearchBarViewDelegate,UITableViewDelegate,UITableViewDataSource,FXYGL_CellDelegate, ADD_FXY_ViewDelegate, GeliAlertViewDelegate {
    func ADD_FXY_ViewFinish(name: String) {
        isAdd = true
        let alertView = GeliAlertView(frame: self.view.window!.bounds)
        alertView.delegate = self;
        alertView.tishiLbl.text = ""
        alertView.titileLbl.text = "是否确定新增“" + name + "”为分销员？"
        alertView.rightBtn.setAttributedTitle(NSAttributedString(string: "确定"), for: .normal)
        self.view.window?.addSubview(alertView)
    }
    
    func sureGeliAlertViewAction(sender: UIButton) {
        if isAdd {
            let dic = [
                "user_token":UserToken as Any,
                "user_name":user_name as Any,
                "phone":phoneNum as Any,
                "type":select_type as Any
            ]
            addDistributor(dic) { (data) in
                self.add_fxy_view?.removeFromSuperview()
                self.add_fxy_view = nil
                self.tableView.mj_header?.beginRefreshing()
            } failture: { (err) in
                
            }
        }else{
            let model = dataArr[sender.tag]
            let dic = [
                "user_token":UserToken as Any,
                "user_id":model.user_id as Any,
            ]
            stopDbtCooperation(dic) { (data) in
                self.tableView.mj_header?.beginRefreshing()
            } failture: { (err) in
                
            }
            
        }
        
        
        
    }
    var select_type = 0
    var phoneNum = ""
    var user_name = ""
    var add_fxy_view:ADD_FXY_View?
    func ADD_FXY_ViewTextInput(txt: String, type: Int, view: ADD_FXY_View) {
        if type == 1 {
            phoneNum = txt
            if phoneNum.count == 11 {
                phoneRetrievalInfo(["user_token":UserToken as Any,"phone":phoneNum as Any]) { (data) in
                    let model = data as! phoneRetrievalInfoModel
                    view.phoneTf.resignFirstResponder()
                    if model.data?.user_name != nil {
                        view.nameTf.text = model.data?.user_name
                        view.nameTf.isUserInteractionEnabled = false
                        self.user_name = (model.data?.user_name)!
                    }else{
                        HUD.flash(.label("请输入分销员名称"), delay: 1.2)
                        view.nameTf.isUserInteractionEnabled = true
                    }
                } failture: { (err) in
                    
                }
                
            }
        }else{
            user_name = txt
            
        }
    }
    
    func ADD_FXY_ViewTypeSelect(type: Int) {
        select_type = type
    }
    var isAdd = true
    func FXYGL_CellCancel_Contract(num: Int) {
        isAdd = false
        let alertView = GeliAlertView(frame: self.view.window!.bounds)
        alertView.delegate = self;
        alertView.tishiLbl.text = ""
        let model = dataArr[num]
        alertView.titileLbl.text = "是否删除“" + model.user_name! + "”分销员？"
        alertView.rightBtn.setAttributedTitle(NSAttributedString(string: "确定"), for: .normal)
        alertView.rightBtn.tag = num
        self.view.window?.addSubview(alertView)
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return dataArr.count
    }
    func rightBtnClick() {
        removeBlackBtnView()
        add_fxy_view = ADD_FXY_View(frame: self.view.bounds)
        add_fxy_view!.delegate = self
        self.view.addSubview(add_fxy_view!)
        
    }
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "FXYGL_Cell") as! FXYGL_Cell
        cell.tag = indexPath.row
        let model = dataArr[indexPath.row]
        var typeStr = " (内部员工)"
        if model.type == 1 {
            typeStr = " (外部员工)"
        }
        cell.typeLbl.text = typeStr
        cell.name_lbl.text = model.user_name!
        cell.count_lbl.text = StringByInt(number: model.count_customers!)
        cell.money_lbl.text = String(format: "%.02f", model.sum_in_amount!)
        cell.time_lbl.text = model.update_time
        cell.delegate = self
        return cell
    }
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 145
    }
    
    @IBOutlet weak var tableView: UITableView!
    @IBOutlet weak var search_view: UIView!
    
    //MARK: - search
    var blackBtnView:UIButton! = nil
    @objc func removeBlackBtnView(){
        if blackBtnView != nil {
            blackBtnView.removeFromSuperview()
            searchV!.resignFirstResponder()
        }
    }
    func searchBarShouldBeginEditing(_ searchBar: UISearchBar) -> Bool {
        print("调起搜索后添加个蒙版本")
        
        blackBtnView = UIButton ()
        blackBtnView.backgroundColor = UIColor.init(named: "提示视图背景色")
        self.view.addSubview(blackBtnView)
        blackBtnView.snp.makeConstraints { (make) in
            make.top.equalTo(search_view!.snp_bottom)
            make.left.right.bottom.equalToSuperview()
        }
        blackBtnView.addTarget(self, action: #selector(removeBlackBtnView), for: .touchUpInside)
        blackBtnView.isUserInteractionEnabled = false
        
        return true
    }
    weak var searchV: SearchBarView? = nil
    var keyword = ""
    func searchBarSearchButtonClicked(_ searchBar: UISearchBar) {
        print("点击搜索进行--")
        searchBar.resignFirstResponder()
        keyword = searchBar.text!
        removeBlackBtnView()
        if keyword.count > 0 {
            
            tableView.mj_header?.beginRefreshing()
        }
    }
    //MARK:--取消搜索代理
    func clearSearchAction() {
        print("取消搜索代理了--")
    }
    func searchBarTextDidEndEditing(_ searchBar: UISearchBar) {
        print("编辑即将结束了--")
        
        removeBlackBtnView()
        if keyword.count > 0 {
            keyword = searchBar.text!
            if keyword.count == 0 {
                
                tableView.mj_header?.beginRefreshing()
            }
        }
    }
    
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = "分销员管理"
        navbar.rightTitle = "新增"
        self.view.addSubview(navbar)
        SetTopFrame(view: search_view, height: 46)
        
        let searchBr = SearchBarView.init()
        searchV = searchBr
        self.search_view.addSubview(searchBr)
        searchV?.changecornerRadius(cornerRadius: 35*0.5)
        searchBr.placeholderStr = "请输入分销商名称/手机号码"
        searchBr.delegate = self
        searchBr.delegateL = self
        
        searchBr.snp.makeConstraints { (make) in
            make.left.equalTo(0)
            make.right.equalTo(0)
            make.centerY.equalToSuperview()
            make.height.equalTo(35)
        }
        
        tableView.separatorStyle = .none
        tableView.showsVerticalScrollIndicator = false
        tableView.register(UINib(nibName: "FXYGL_Cell", bundle: nil), forCellReuseIdentifier: "FXYGL_Cell")
        headerMJ.setRefreshingTarget(self, refreshingAction: #selector(loadData))
        tableView.mj_header = self.headerMJ
        tableView.mj_header?.beginRefreshing()
        
        self.footerMJ.setRefreshingTarget(self, refreshingAction: #selector(loadMoreData))
        tableView.mj_footer = self.footerMJ
        // Do any additional setup after loading the view.
    }
    
    let UserToken = UserDefaults.standard.value(forKey: "user_token")
    var page : Int = 0
    var isUpData = false
    var dataArr:Array<dbtManageQueryDatasModel> = []
    @objc func loadData(){
        page = 1
        isUpData = true
        
        let dic = ["user_token":UserToken as Any,
                   "keyword":keyword as Any,
                   "page":page as Any
        ]
        
        dbtManageQuery(dic) { (data) in
            self.dataArr.removeAll()
            let model = data as! dbtManageQueryModel
            model.data?.res?.forEach({ (item) in
                self.dataArr.append(item)
            })
            self.tableView.reloadData()
            self.tableView?.mj_header?.endRefreshing()
            self.page = 2
            
            if model.data?.res?.count == nil ||  model.data?.res?.count == 0 {
                self.tableView?.mj_footer?.endRefreshingWithNoMoreData()
            }else{
                self.tableView?.mj_footer?.endRefreshing()
            }
        } failture: { (err) in
            self.tableView?.mj_header?.endRefreshing()
        }
    }
    //MARK:--加载更多数据
    @objc func loadMoreData(){
        print("加载更多数据")
        let dic = ["user_token":UserToken as Any,
                   "keyword":keyword as Any,
                   "page":page as Any
        ]
        dbtManageQuery(dic, success: { (data) in
            let model = data  as! dbtManageQueryModel
            if model.data?.res?.count == nil ||  model.data?.res?.count == 0 {
                self.tableView?.mj_footer?.endRefreshingWithNoMoreData()
            }else{
                self.page += 1
                model.data?.res?.forEach({ (item) in
                    self.dataArr.append(item)
                })
                
                self.tableView.reloadData()
                self.tableView?.mj_footer?.endRefreshing()
            }
        }) { (error) in
            self.tableView?.mj_footer?.endRefreshing()
        }
    }
}
      
