//
//  DZGL_Cell.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2021/3/19.
//  Copyright © 2021 junye lu. All rights reserved.
//

import UIKit
protocol DZGL_Cell_Delegate {
    func DZGL_Cell_Del_Action(cell:DZGL_Cell)
    func DZGL_Cell_Edit_Action(cell:DZGL_Cell)
}
class DZGL_Cell: UITableViewCell {
    var delegate:DZGL_Cell_Delegate?
    @IBOutlet weak var img_view: UIImageView!
    @IBOutlet weak var name_lbl: UILabel!
    @IBOutlet weak var adr_lbl: UILabel!
    @IBOutlet weak var relation_lbl: UILabel!
    @IBOutlet weak var status_lbl: UILabel!
    @IBOutlet weak var time_lbl: UILabel!
    @IBOutlet weak var del_Btn: UIButton!
    @IBAction func del_action(_ sender: UIButton) {
        delegate?.DZGL_Cell_Del_Action(cell: self)
    }
    @IBAction func edit_action(_ sender: UIButton) {
        delegate?.DZGL_Cell_Edit_Action(cell: self)
    }
    override func awakeFromNib() {
        super.awakeFromNib()
        self.selectionStyle = .none
        
    }

    override func setSelected(_ selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)

        // Configure the view for the selected state
    }
    
}
