//
//  PPH_Detail_Cell.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2021/4/8.
//  Copyright © 2021 junye lu. All rights reserved.
//

import UIKit

class PPH_Detail_Cell: UITableViewCell {

    var isLast = false
    @IBOutlet weak var bg_view: UIView!
    @IBOutlet weak var top_right_view: UIView!
    @IBOutlet weak var top_left_view: UIView!
    @IBOutlet weak var commend_lbl: UILabel!
    @IBOutlet weak var conect_lbl: UILabel!
    @IBOutlet weak var adr_lbl: UILabel!
    @IBOutlet weak var title_lbl: UILabel!
    @IBOutlet weak var status_lbl: UILabel!
  
    @IBOutlet weak var bottom_line: UIImageView!
    @IBOutlet weak var top_line: UIImageView!
    override func awakeFromNib() {
        super.awakeFromNib()
        self.selectionStyle = .none
        
        // Initialization code
    }
        
  
    
    override func layoutIfNeeded() {
        super.layoutIfNeeded()
        if isLast {
            setYuanJiao2(sender: bg_view, radii: 10)
        }else{
            setYuanJiao2(sender: bg_view, radii: 0)
        }
    }
    func setYuanJiao2(sender:UIView,radii:Int){
        let maskPath = UIBezierPath(roundedRect: sender.bounds,
                                    byRoundingCorners:[.bottomLeft, .bottomRight], cornerRadii:CGSize(width:radii, height:radii))
        let masklayer = CAShapeLayer()
        masklayer.frame = sender.bounds
        masklayer.path = maskPath.cgPath
        sender.layer.mask = masklayer
    }
    override func setSelected(_ selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)

        // Configure the view for the selected state
    }
    
}
