//
//  P_P_H_YDLB_VC.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2021/4/1.
//  Copyright © 2021 junye lu. All rights reserved.
//

import UIKit

class P_P_H_YDLB_VC: BaseViewController,UITableViewDelegate,UITableViewDataSource {
   
    @IBOutlet weak var line_view: UIView!
    @IBAction func click_action(_ sender: UIButton) {
        line_view.center.x = sender.center.x
        if sender == receive_btn {
            receive_btn.isSelected = true
            send_btn.isSelected = false
        }else{
            receive_btn.isSelected = false
            send_btn.isSelected = true
        }
        list_view.mj_header?.beginRefreshing()
    }
    @IBOutlet weak var receive_btn: UIButton!
    @IBOutlet weak var send_btn: UIButton!
 	
    @IBOutlet weak var list_view: UITableView!
    @IBOutlet weak var top_btn_view: UIView!
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = "运单列表"
        self.view.addSubview(navbar)
        SetTopFrame(view: top_btn_view, height: 44)
        list_view.separatorStyle = .none
        list_view.register(UINib(nibName: "YunDanLieBiaoCell", bundle: nil), forCellReuseIdentifier: "YunDanLieBiaoCell")
        
        headerMJ.setRefreshingTarget(self, refreshingAction: #selector(loadData))
        list_view.mj_header = self.headerMJ
        list_view.mj_header?.beginRefreshing()
        
        footerMJ.setRefreshingTarget(self, refreshingAction: #selector(loadMoreData))
        list_view.mj_footer = self.footerMJ
    }

    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return 3
    }
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 181
    }
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "YunDanLieBiaoCell") as! YunDanLieBiaoCell
        
        return cell
    }
    var page = 0
    let UserToken = UserDefaults.standard.value(forKey: "user_token")
    var isUpData = false{
        didSet{
            if !isUpData {
                if list_view  != nil {
                    list_view.mj_header?.beginRefreshing()
                }
            }
        }
    }
    @objc func loadData(){
      
        page = 1
        isUpData = true
//        dbtList(["page":page as Any,"user_token":UserToken as Any,"is_shopowner":is_shopowner as Any,"keyword":keyword as Any]) { (data) in
//            self.dbt_datas.removeAll()
//            let model = data as! dbtListModel
//            model.data?.forEach({ (item) in
//                self.dbt_datas.append(item)
//            })
            self.list_view.reloadData()
            self.list_view?.mj_header?.endRefreshing()
//            if model.data?.count == 0 {
//                self.list_view?.mj_footer?.endRefreshingWithNoMoreData()
//            }else{
//                self.list_view?.mj_footer?.endRefreshing()
//            }
//            self.page = 2
//        } failture: { (err) in
//            self.list_view?.mj_header?.endRefreshing()
//        }
    }
    
    @objc func loadMoreData(){
//        dbtList(["page":page as Any,"user_token":UserToken as Any,"is_shopowner":is_shopowner as Any,"keyword":keyword as Any]){ (data) in
//            let dataM = data as! dbtListModel
//            if dataM.data?.count == 0 {
//                self.list_view.mj_footer?.endRefreshingWithNoMoreData()
//            }else{
//                self.page += 1
//                dataM.data?.forEach({ (model) in
//                    self.dbt_datas.append(model)
//                })
//                self.list_view.reloadData()
//                self.list_view.mj_footer?.endRefreshing()
//            }
//        } failture: { (error) in
//            self.list_view.mj_footer?.endRefreshing()
//        }
    }

}
