//
//  Print_Gprinter_View.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2021/1/27.
//  Copyright © 2021 junye lu. All rights reserved.
//

import UIKit
import LGButton
protocol Print_Gprinter_View_Delegate {
    func Print_Gprinter_View_Print(data:Array<Dictionary<String,Any>>)
}
class Print_Gprinter_View: UIView,UITableViewDelegate,UITableViewDataSource, GPrinter_Cell_Delegate {
    func GPrinter_Cell_print_copy(num: Array<Int>, cell: GPrinter_Cell) {
        print_num_arr.insert(num, at: cell.tag)
        print_num_arr.remove(at: cell.tag+1)
    }
    var delegate:Print_Gprinter_View_Delegate?
    func GPrinter_Cell_select_item(selects: Array<Int>, cell: GPrinter_Cell) {
        pi_ci_select.insert(selects, at: cell.tag)
        pi_ci_select.remove(at: cell.tag+1)
        cell.layoutIfNeeded()
        list_view.reloadData()
    }
    
    var print_num_arr:Array<Array<Int>> = []
    
    
    
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return rkSelectArr.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "GPrinter_Cell") as! GPrinter_Cell
        cell.delegate = self
        cell.select_arr = pi_ci_select[indexPath.row]
        cell.print_copy_arr = print_num_arr[indexPath.row]
        cell.tag = indexPath.row
        let model = rkSelectArr[indexPath.row]
        cell.name_lbl.text = model.goods_name
        cell.piciArr = piCiArr![indexPath.row]
        cell.btm_line.isHidden = false
        if indexPath.row == rkSelectArr.count - 1 {
            cell.btm_line.isHidden = true
        }
        return cell
    }
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        let pici = piCiArr![indexPath.row]
        return CGFloat(103 + 67 * pici.count)
    }
    var rkSelectArr:Array<InputInitInfoGoodsInfoModel> = []{
        didSet {
            for i in 0 ..< rkSelectArr.count {
                pi_ci_select.append([])
                print_num_arr.append([])
            }
        }
    }//产品选择
    var piCiArr:Array<Array<GetGoodBatchDataModel>>? = []
    var contentView:UIView!
    var pi_ci_select:Array<Array<Int>> = []
    @IBOutlet weak var list_view: UITableView!
    @IBAction func print_action(_ sender: LGButton) {
        var temp_rk_arr:Array<Int> = []
        for i in 0 ..< rkSelectArr.count {
            let arr = pi_ci_select[i]
            for item in arr {
                if item != 999999 {
                    temp_rk_arr.append(i)
                    break
                }
            }
        }
        var temp_print_arr:Array<Array<Int>> = []
        for item in temp_rk_arr {
            let arr = pi_ci_select[item]
            var arr2:Array<Int> = []
            for i in arr {
                if i != 999999 {
                    arr2.append(i)
                }
            }
            temp_print_arr.append(arr2)
        }
       
        var print_data:Array<Dictionary<String,Any>> = []
        for item in temp_rk_arr {
            let model = rkSelectArr[item]
            let select_arr = temp_print_arr[item]
            var dict:Dictionary<String,Any> = Dictionary()
            for i in select_arr {
                dict["goods_name"] = model.goods_name
                let p = piCiArr![item][i]
                dict["goods_data"] = p
                let n = print_num_arr[item][i]
                dict["print_counts"] = n
                print_data.append(dict)
            }
        }
        for item in print_data {
            let data = item["goods_data"] as! GetGoodBatchDataModel
            print("print_target = ",item["goods_name"],data.batch_id,item["print_counts"])
        }
        //连接打印机
        delegate?.Print_Gprinter_View_Print(data: print_data)
    }
    @IBAction func close_action(_ sender: UIButton) {
        self.removeFromSuperview()
    }
    //初始化时将xib中的view添加进来
    override init(frame: CGRect) {
        super.init(frame: frame)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
        list_view.register(UINib(nibName: "GPrinter_Cell", bundle: nil), forCellReuseIdentifier: "GPrinter_Cell")
        list_view.separatorStyle = .none
    }
    //    /初始化时将xib中的view添加进来
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
        list_view.register(UINib(nibName: "GPrinter_Cell", bundle: nil), forCellReuseIdentifier: "GPrinter_Cell")
        list_view.separatorStyle = .none
    }
    //加载xib
    func loadViewFromNib() -> UIView {
        let className = type(of: self)
        let bundle = Bundle(for: className)
        let name = NSStringFromClass(className).components(separatedBy: ".").last
        let nib = UINib(nibName: name!, bundle: bundle)
        let view = nib.instantiate(withOwner: self, options: nil).first as! UIView
        return view
    }
    
}
