//
//  S_Y_View.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2021/1/26.
//  Copyright © 2021 junye lu. All rights reserved.
//

import UIKit
protocol S_Y_View_Delegate {
    func S_Y_View_Check_Detail(data:OrderDetailGoodsSourceModel)
}
class S_Y_View: UIView ,UITableViewDelegate,UITableViewDataSource,S_Y_View_Cell_delegate{
    func S_Y_View_Cell_btn_click(cell: S_Y_View_Cell) {
        if cell.data == nil {
            return
        }
        delegate?.S_Y_View_Check_Detail(data: cell.data!)
    }
    
    var data:Array<OrderDetailGoodsSourceModel>? {
        didSet{
            if data != nil {
                if data!.count > 1 {
                    viewHiehgt.constant = 425
                }
                listView.reloadData()
            }
        }
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return data!.count
    }
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 309
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "S_Y_View_Cell") as! S_Y_View_Cell
        cell.tag = indexPath.row
        cell.data = data![indexPath.row]
        cell.delegate = self
        return cell
    }
    
    @IBOutlet weak var viewHiehgt: NSLayoutConstraint!
    var contentView:UIView!
    var delegate:S_Y_View_Delegate?
    @IBOutlet weak var listView: UITableView!
    
    @IBAction func close_action(_ sender: UIButton) {
        self.removeFromSuperview()
    }
    //初始化时将xib中的view添加进来
    override init(frame: CGRect) {
        super.init(frame: frame)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
        listView.register(UINib(nibName: "S_Y_View_Cell", bundle: nil), forCellReuseIdentifier: "S_Y_View_Cell")
        listView.separatorStyle = .none
    }
    //    /初始化时将xib中的view添加进来
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
        listView.register(UINib(nibName: "S_Y_View_Cell", bundle: nil), forCellReuseIdentifier: "S_Y_View_Cell")
        listView.separatorStyle = .none
//        bao_zhi_qi_lbl.text = "-"
//        sheng_chan_ri_qi_lbl.text = "-"
//        chan_di_lbl.text = "-"
//        ru_ku_time_lbl.text = "-"
//        pi_ci_number_lbl.text = "-"
//        gys_name_lbl.text = "-"
    }
    //加载xib
    func loadViewFromNib() -> UIView {
        let className = type(of: self)
        let bundle = Bundle(for: className)
        let name = NSStringFromClass(className).components(separatedBy: ".").last
        let nib = UINib(nibName: name!, bundle: bundle)
        let view = nib.instantiate(withOwner: self, options: nil).first as! UIView
        return view
    }

}
